SystemOrganization addCategory: #'WebStore-Core'!
SystemOrganization addCategory: #'WebStore-Announcements'!
SystemOrganization addCategory: #'WebStore-Components'!
SystemOrganization addCategory: #'WebStore-Admin'!
SystemOrganization addCategory: #'WebStore-Util'!
SystemOrganization addCategory: #'WebStore-Checkout'!
SystemOrganization addCategory: #'WebStore-Commands'!
SystemOrganization addCategory: #'WebStore-MagmaPools'!
SystemOrganization addCategory: #'WebStore-Messages'!
SystemOrganization addCategory: #'WebStore-Expression'!
SystemOrganization addCategory: #'WebStore-Analytics'!

Error subclass: #WSOrderError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

WAComponent subclass: #WSAdminPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSAdminPage methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:16'!
actions
	^Array with: 'Done' -> [self answer]! !

!WSAdminPage methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 22:14'!
renderActionsOn: html
	html div class: #actions; with: [
		self actions 
			do: [ :action |
				html anchor callback: action value; with: action key]
			separatedBy: [ html space ]]! !

!WSAdminPage methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 22:22'!
renderBodyOn: html
	self children do: 
		[ :c | html render: c]! !

!WSAdminPage methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 22:17'!
renderContentOn: html
	self renderActionsOn: html.
	self renderBodyOn: html! !

!WSAdminPage methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2009 13:16'!
title
	^self subclassResponsibility! !

!WSAdminPage methodsFor: 'updating' stamp: 'StuartHerring 9/12/2009 13:17'!
updateRoot: anHtmlRoot
	anHtmlRoot title: self title.! !

WSAdminPage subclass: #WSIPNLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSIPNLog class methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:45'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSIPNLog methodsFor: 'initialization' stamp: 'StuartHerring 9/8/2009 07:54'!
initializeWithStore: aStore
	self initialize ! !

!WSIPNLog methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2009 13:18'!
title
	^'IPN Log'! !

WSAdminPage subclass: #WSMessageLog
	instanceVariableNames: 'messageLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSMessageLog class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:53'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSMessageLog methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:23'!
children
	^{messageLog}! !

!WSMessageLog methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 22:25'!
initializeWithStore: aStore
	super initialize.
	messageLog := WSMessageHistory messages: aStore messages.! !

!WSMessageLog methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2009 13:56'!
title
	^'Message Log'! !

WSAdminPage subclass: #WSOptionAdminPage
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOptionAdminPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2009 13:24'!
allPages
	^WSOptionAdminPage allSubclasses reject: [ :c | c isAbstract ]! !

!WSOptionAdminPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2009 13:30'!
isAbstract
	^self = WSOptionAdminPage.! !

!WSOptionAdminPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2009 13:30'!
store: aStore
	^self basicNew 
		initializeWithStore: aStore;
		yourself! !

!WSOptionAdminPage methodsFor: 'initialization' stamp: 'StuartHerring 9/12/2009 13:31'!
initializeWithStore: aStore
	self initialize.
	store := aStore! !

WSAdminPage subclass: #WSOrderManager
	instanceVariableNames: 'filter store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderManager class methodsFor: 'as yet unclassified' stamp: 'srh 1/29/2009 13:47'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/28/2009 23:01'!
formatDate: aDate
	^aDate asDate printFormat: #(3 2 1 $- 1 1 2) ! !

!WSOrderManager methodsFor: 'initialization' stamp: 'srh 2/2/2009 17:56'!
initializeWithStore: aStore
	store := aStore.
	self initialize.! !

!WSOrderManager methodsFor: 'accessing' stamp: 'srh 2/28/2009 16:42'!
orders
	^filter isNil 
		ifTrue: [store orders]
		ifFalse: [store orders select: [ :o | o status is: filter ]].! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 23:31'!
renderAction: actionText withPrompt: promptText callback: aSingleArgumentBlock on: html
	html anchor
		callback: [| answer |
			answer := self call: (WSCancelableInputDialog message: promptText).
			answer ifNotNil: [ aSingleArgumentBlock value: answer ]];
		with: actionText
! !

!WSOrderManager methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 22:28'!
renderBodyOn: html
	self renderFilterOn: html.
	self renderOrderListOn: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:38'!
renderCancelActionFor: anOrder on: html 
	self renderAction: 'Cancel' 
		withPrompt: 'Please enter a reason for cancelling the order' 
		callback: [ :reason | 
			(WSCancelOrderCommand order: anOrder	reason: reason) run ] 
		on: html. 
! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:40'!
renderConfirmActionFor: anOrder on: html
	self renderAction: 'Confirm' 
		withPrompt: 'Please the Paypal Payment Reference' 
		callback: [ :reference | 
			(WSConfirmPaymentCommand  	order: anOrder	reference: reference) run ] 
		on: html.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 23:22'!
renderConfirmedActionsFor: anOrder on: html
	self renderShipActionFor: anOrder on: html.
	html space.
	self renderCancelActionFor: anOrder on: html! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:34'!
renderFilterOn: html
	html form: [ |id|
		id := html nextId.
		html label for: id; with: 'Show: '.
		html select 
			id: id; 
			beSubmitOnChange; 
			beOptional; 
			selected: filter;
			list: #(unconfirmed confirmed cancelled shipped);
			labels: [ :o | o asCapitalizedPhrase];
			optionalLabel: 'All';
			callback: [ :value | filter := value]]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/10/2009 06:00'!
renderOrderListOn: html 
	html table: 
		[ html tableRow: 
			[ html tableHeading: 'Reference'.
			html tableHeading: 'Customer'.
			html tableHeading: 'Items'.
			html tableHeading: 'Total'.
			html tableHeading: 'Date'.
			html tableHeading: 'Status' ].
		self orders do: 
			[ :o | 
			html tableRow: 
				[ html tableData: 
					[ html anchor
						callback: [ self viewOrder: o ];
						with: o reference ].
				html tableData: o customer name.
				html tableData: o count printString.
				html tableData: '$' , o totalInDollars.
				html tableData: (self formatDate: o date).
				html tableData: 
					[ self 
						renderStatus: o status
						on: html.
					self 
						renderStatusActionsFor: o
						on: html ] ] ] ]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:41'!
renderShipActionFor: anOrder on: html
	self renderAction: 'Ship' 
		withPrompt: 'Please enter the shipping reference number' 
		callback: [ :reference | 
			(WSShipOrderCommand order: anOrder reference: reference) run ] 
		on: html.! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 16:39'!
renderStatus: aStatus on: html.
	html text: aStatus name asCapitalizedPhrase, ' (', (self formatDate: aStatus date), ')'.
! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 19:42'!
renderStatusActionsFor: anObject on: html
	| selector |
	selector := ('render', anObject status name displayString capitalized, 'ActionsFor:on:') asSymbol.
	(self respondsTo: selector) ifTrue: [
		self perform: selector with: anObject with: html]! !

!WSOrderManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:06'!
renderUnconfirmedActionsFor: anOrder on: html
	self renderCancelActionFor: anOrder on: html.
	html space.
	self renderConfirmActionFor: anOrder on: html! !

!WSOrderManager methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2009 13:18'!
title
	^'Manage Orders'! !

!WSOrderManager methodsFor: 'view order' stamp: 'srh 4/27/2009 12:10'!
viewOrder: anOrder
	self call: (WSOrderDetails order: anOrder)! !

WSAdminPage subclass: #WSProductManager
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductManager class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSProductManager methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:29'!
actions
	^{'Add Product' -> [ self addProduct].
	'Done' -> [self answer]}! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:43'!
addProduct
	| p |
	p := self call: WSProductEditor new.
	p ifNotNil: [	(WSAddProductCommand store: store product: p) run]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/4/2009 23:41'!
copyProduct: product
	| p |
	p := self call: (WSProductEditor copyOf: product).
	p ifNotNil: [	(WSAddProductCommand store: store product: p) run]! !

!WSProductManager methodsFor: 'actions' stamp: 'srh 2/28/2009 21:44'!
deleteProduct: p
	(self confirm: 'Really delete ',p name, '?') ifTrue: [
		(WSDeleteProductCommand store: store product: p) run ]! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 20:01'!
editProduct: aProduct 
	self call: (WSProductEditor product: aProduct)! !

!WSProductManager methodsFor: 'initialization' stamp: 'srh 2/5/2009 20:51'!
initializeWithStore: aStore
	self initialize.
	store := aStore! !

!WSProductManager methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 22:30'!
renderBodyOn: html
	self renderStatsOn: html.
	self renderProductListOn: html! !

!WSProductManager methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/15/2009 14:16'!
renderProductListOn: html 
	html table: 
		[ html tableRow: 
			[ html tableHeading.
			html tableHeading: 'Name'.
			html tableHeading: 'Price'.
			html tableHeading: 'Actions' ].
		store products do: 
			[ :p | 
			html tableRow: 
				[ html tableData: [ p preview ifNotNil: [ html wsImage: p preview thumbnail ] ].
				html tableData: p name.
				html tableData: p priceInDollars.
				html tableData: 
					[ html anchor
						callback: [ self deleteProduct: p ];
						with: 'Delete'.
					html space.
					html anchor
						callback: [ self editProduct: p ];
						with: 'Edit'.
					html space.
					p enabled 
						ifTrue: 
							[ html anchor
								callback: [ (WSDisableProductCommand product: p) run ];
								with: 'Disable' ]
						ifFalse: 
							[ html anchor
								callback: [ (WSEnableProductCommand product: p) run ];
								with: 'Enable' ].
					html space.
					html anchor
						callback: [ self copyProduct: p ];
						with: 'Copy' ] ] ] ]
			! !

!WSProductManager methodsFor: 'rendering' stamp: 'srh 5/19/2009 20:47'!
renderStatsOn: html
	html div class: #stats; with: [
		html paragraph: store products size printString, ' products']! !

!WSProductManager methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2009 13:17'!
title
	^'Manage Products'! !

WAComponent subclass: #WSAnalyticsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Analytics'!

!WSAnalyticsTest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2010 22:49'!
canBeRoot
	^true! !

!WSAnalyticsTest methodsFor: 'rendering' stamp: 'StuartHerring 3/24/2010 23:21'!
renderContentOn: html
	html heading level: 1; with: 'Hello, World!!'.
	html anchor 
		onClick: (WSEventTracker category: 'Foo' event:  'Bar' label: 'Baz' value: 45);
		with: 'Click Me!!'! !

!WSAnalyticsTest methodsFor: 'updating' stamp: 'StuartHerring 3/24/2010 22:47'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot add: (WSAnalytics key: nil)! !

WAComponent subclass: #WSCancelableInputDialog
	instanceVariableNames: 'message value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSCancelableInputDialog class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 17:05'!
message: aMessage
	^self basicNew
		initializeWithMessage: aMessage;
		yourself! !

!WSCancelableInputDialog methodsFor: 'initialization' stamp: 'srh 3/9/2009 11:13'!
initializeWithMessage: aMessage
	self initialize.
	message := aMessage.! !

!WSCancelableInputDialog methodsFor: 'rendering' stamp: 'srh 2/28/2009 21:07'!
renderContentOn: html
	html heading level: 3; with: message.
	html form
		defaultAction: [self submit];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton value: 'Ok';
				callback: [ self submit].
			html space.
			html cancelButton value: 'Cancel'; callback: [self answer: nil] ]! !

!WSCancelableInputDialog methodsFor: 'actions' stamp: 'srh 2/28/2009 21:07'!
submit
	(value notNil and: [value notEmpty ]) ifTrue: [
		self answer: value] 
! !

!WSCancelableInputDialog methodsFor: 'accessing' stamp: 'srh 2/28/2009 17:08'!
value
	^value! !

!WSCancelableInputDialog methodsFor: 'accessing' stamp: 'srh 2/28/2009 17:07'!
value: aValue
	value := aValue.! !

WAComponent subclass: #WSCheckoutWizard
	instanceVariableNames: 'page order pages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:37'!
back
	^ page := pages before: page! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:37'!
cancel
	^ self answer: nil! !

!WSCheckoutWizard methodsFor: 'accessing' stamp: 'cmd 3/21/2009 16:46'!
children
	^Array with: page! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 1/3/2009 10:34'!
goToFirstPage
	page := pages first! !

!WSCheckoutWizard methodsFor: 'initialization' stamp: 'StuartHerring 9/10/2009 08:22'!
initialize
	super initialize.
	page := WSCustomerPage new.
	pages := OrderedCollection new
		add: WSCartViewPage new;
		add: page;
		add: WSConfirmOrderPage new;
		yourself.
	order := self session cart.
	pages do: [ :p | p model: order ].
	page onEnter.! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'srh 6/28/2009 21:36'!
next
	^ (page save and: [ page valid ]) ifTrue: 
		[ page := pages after: page.
		page onEnter ]! !

!WSCheckoutWizard methodsFor: 'actions' stamp: 'StuartHerring 11/18/2009 22:24'!
pay
	^ (page save and: [ page valid ]) 
		ifTrue: [ self answer: order ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:53'!
renderBackButtonOn: html 
	page = pages first ifFalse: 
		[ html cancelButton
			callback: [ self back ];
			value: 'Previous' ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:54'!
renderButtonsOn: html 
	html div
		class: 'nav-buttons';
		with: 
			[ self renderBackButtonOn: html.
			html space.
			self renderNextButtonOn: html.
			html space.
			self renderCancelButtonOn: html ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:54'!
renderCancelButtonOn: html 
	^ html cancelButton
		callback: [ self cancel ];
		value: 'Cancel'! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'srh 6/28/2009 21:55'!
renderContentOn: html
	self renderNavOn: html.
	html form
		defaultAction: [ page = pages last ifTrue: [ self pay] ifFalse: [ self next ]];
		with: [
		html render: page.
		self renderButtonsOn: html
	]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'StuartHerring 11/18/2009 21:54'!
renderNavOn: html 
	html unorderedList
		class: 'wizard-tabs';
		with: 
			[ pages do: 
				[ :p | | enabled |
				enabled := p enabled and: [ pages first valid ].
				html listItem
					class: (enabled ifFalse: [ 'disabled' ] ifTrue: [ p = page ifTrue: [ 'active']]);
					with: 
						[ (p = page or: [ enabled not ]) 
							ifTrue: [ html text: p title ]
							ifFalse: 
								[ html anchor
									callback: [ page := p ];
									with: p title ] ] ] ]! !

!WSCheckoutWizard methodsFor: 'rendering' stamp: 'StuartHerring 3/22/2010 20:57'!
renderNextButtonOn: html 
	page = pages last 
		ifFalse: 
			[ (page = pages first and: [ page valid not ])  
				ifFalse: [html submitButton
					callback: [ self next ];
					value: 'Next' ]]
		ifTrue: 
			[ html submitButton
				onClick: (WSOrderEvent payForOrder: order);
				callback: [ self pay ];
				value: 'Pay with Paypal' ]! !

!WSCheckoutWizard methodsFor: 'accessing' stamp: 'StuartHerring 11/16/2009 19:23'!
states
	^Array with: self! !

!WSCheckoutWizard methodsFor: 'accessing' stamp: 'srh 4/22/2009 00:17'!
title
	^page title! !

WAComponent subclass: #WSComponent
	instanceVariableNames: 'baseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSComponent subclass: #WSCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/14/2009 11:26'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartView class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:53'!
new
	self shouldNotImplement! !

!WSCartView methodsFor: 'accessing' stamp: 'srh 1/4/2009 13:57'!
cart
	^cart! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/18/2009 19:20'!
editItem: aProductEntry
	self announce: (WSOpenDialogue component: (WSProductDetails edit: aProductEntry ))! !

!WSCartView methodsFor: 'initialization' stamp: 'srh 3/14/2009 11:26'!
initializeWithCart: aCart
	cart := aCart.
	self initialize.
! !

!WSCartView methodsFor: 'rendering' stamp: 'srh 6/28/2009 22:21'!
renderContentOn: html 
	html div
		class: 'cart-view';
		with: 
			[ cart isEmpty 
				ifTrue: [ self renderEmptyOrderOn: html ]
				ifFalse: [ self renderOrderContentsOn: html ] ]! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'srh 6/28/2009 22:14'!
renderEmptyOrderOn: html
	html paragraph: 'Your order contains no items.'! !

!WSCartView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2009 10:34'!
renderOrderContentsOn: html 
	^ html table: 
		[ html tableRow: 
			[ html tableHeading
				colSpan: 2;
				with: 'Item'.
			html tableHeading: 'Price'.
			html tableHeading ].
		html tableBody
			id: 'cart-items';
			with: 
				[ self cart do: 
					[ :p | 
					html tableRow: 
						[ html tableData: [ p preview ifNotNil: [ html wsImage: p preview thumbnail ] ].
						html tableData: 
							[ html anchor
								callback: [ self editItem: p ];
								with: p name ].
						html tableData: '$' , p totalInDollars.
						html tableData: 
							[ html anchor
								callback: [ self cart remove: p ];
								with: 'Remove' ] ] ] ].
		html tableRow: 
			[ html tableData.
			html tableData: 'Total: '.
			html tableHeading
				id: 'cart-total';
				with: '$' , self cart totalInDollars.
			html tableData ] ]! !

WSComponent subclass: #WSCartViewDialog
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSCartViewDialog class methodsFor: 'as yet unclassified' stamp: 'srh 3/9/2009 15:44'!
new
	self shouldNotImplement! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 1/1/2009 10:59'!
children
	^Array with: cartView.! !

!WSCartViewDialog methodsFor: 'accessing' stamp: 'srh 3/21/2009 12:50'!
initializeWithCart: aCart
	self initialize.
	cartView := WSCartView cart: aCart! !

!WSCartViewDialog methodsFor: 'rendering' stamp: 'StuartHerring 3/22/2010 21:01'!
renderContentOn: html
		html render: cartView.
		html div class: 'nav-buttons'; with: [
		html anchor callback: [ self answer]; with: 'Back'.
		cartView cart isEmpty ifFalse: [ html text: ' '.
			html anchor 
				extraPath: 'checkout'; 
				onClick: (WSOrderEvent checkoutOrder: cartView cart);
				callback: [ self answer: (self call: WSCheckoutProcess new) ]; 
				with: 'Checkout']]! !

!WSCartViewDialog methodsFor: 'rendering' stamp: 'srh 4/22/2009 00:16'!
title
	^'Current Order'! !

WSComponent subclass: #WSCartWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSCartWidget methodsFor: 'accessing' stamp: 'srh 12/31/2008 14:34'!
cart
	^self session cart.! !

!WSCartWidget methodsFor: 'rendering' stamp: 'StuartHerring 3/22/2010 20:55'!
renderContentOn: html 
	self cart isEmpty ifFalse: 
		[ html div
			class: 'cart-widget';
			with: 
				[ html heading
					level: 3;
					with: 'Your Order'.
				html paragraph: 'Items: ' , self cart count printString , ' Total: $' , self cart totalInDollars.
				html paragraph: 
					[ html anchor
						onClick: (WSOrderEvent reviewOrder: self cart);
						callback: [ self announce: (WSReviewCart cart: self cart)  ];
						with: 'Review / Checkout' ] ] ]! !

!WSComponent methodsFor: 'updating' stamp: 'srh 3/10/2009 21:27'!
announce: anAnnouncement
	^self session announce: anAnnouncement! !

!WSComponent methodsFor: 'accessing' stamp: 'srh 3/30/2009 17:48'!
baseUrl
    ^ (baseUrl ifNil: [ baseUrl := self session baseUrl ]) copy! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:27'!
lightbox: aComponent
	self announce: (WSLightbox component: aComponent)! !

!WSComponent methodsFor: 'accessing' stamp: 'srh 4/22/2009 00:12'!
title
	^''! !

!WSComponent methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 12:40'!
urlForProduct: aProduct
	^self session urlForProduct: aProduct! !

WSComponent subclass: #WSEditOrderItem
	instanceVariableNames: 'product form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

WSEditOrderItem subclass: #WSAddOrderItem
	instanceVariableNames: 'visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSAddOrderItem methodsFor: 'actions' stamp: 'StuartHerring 9/6/2009 23:42'!
addProduct: aProduct
	self announce: (WSAddToCart product: aProduct)! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	self addProduct: product! !

!WSAddOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:41'!
buttonText
	^'Add to Order'! !

!WSAddOrderItem methodsFor: 'initialization' stamp: 'StuartHerring 3/22/2010 19:52'!
initialize
	super initialize.
	visible := false.! !

!WSAddOrderItem methodsFor: 'rendering' stamp: 'StuartHerring 3/22/2010 20:53'!
renderContentOn: html
	
	visible 
		ifFalse: [	
			product options size > 0 
				ifTrue: [html anchor 
					onClick: (WSProductEvent customizeProduct: product) ;
					callback: [ visible := true]; text: 'Customize']
				ifFalse: [ html anchor 
					onClick: (WSProductEvent addProduct: product);
					callback: [ self addProduct: product ]; text: 'Add to Order']]
		ifTrue: [ super renderContentOn: html].! !

!WSAddOrderItem methodsFor: 'accessing' stamp: 'srh 3/13/2009 20:40'!
title
	^'Add Item'! !

!WSEditOrderItem class methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:24'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 22:20'!
beforeAnswer
	"nothing!!"
	! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'srh 3/13/2009 20:38'!
buttonText
	^'Save'! !

!WSEditOrderItem methodsFor: 'menu messages' stamp: 'srh 3/12/2009 22:07'!
cancel
	^self answer: nil! !

!WSEditOrderItem methodsFor: 'accessing' stamp: 'srh 3/11/2009 14:46'!
children
	^Array with: form.! !

!WSEditOrderItem methodsFor: 'initialization' stamp: 'StuartHerring 11/24/2009 13:26'!
initializeWithProduct: aProduct
	self initialize.
	form := WSOrderCustomizationForm new.
	product := aProduct.
	self setUpFields.
! !

!WSEditOrderItem methodsFor: 'rendering' stamp: 'StuartHerring 3/22/2010 20:53'!
renderContentOn: html
		html form id: 'add-item'; with: [
		self renderItemOn: html.
		html div id: 'ws-orderTotal'; with: [ 
			self renderTotalOn: html].
		html div class: 'nav-buttons'; with: [
		html submitButton
			onClick: (WSProductEvent addProduct: product);
			callback: [ self saveAndAnswer ]; with:self buttonText.
		html text: ' '.
		html cancelButton callback: [ self cancel]; with: 'Cancel']]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/11/2009 16:23'!
renderItemOn: html 
	product options ifNotEmpty: 
		[ html paragraph: 'This item requires additional information before it can be added to your order'.
		html render: form ]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2011 11:54'!
renderTotalOn: html
	html fieldSet: [
		html legend: 'Summary'.
		html table: [
			html tableRow: [ 
				html tableHeading: 'Base Price'. 
				html tableData: product priceInDollars].
			form fields do: [ :field |
				field price > 0 ifTrue: [
					html tableRow: [
						html tableHeading: field label.
						html tableData: ((field price / 100) printShowingDecimalPlaces: 2)]]].
			html tableRow class: #total; with: [
				html tableHeading: 'Total'.
				html tableData: product totalInDollars]]]
! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 00:55'!
saveAndAnswer
	form save ifTrue: [
		self beforeAnswer.
		self answer: product]! !

!WSEditOrderItem methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2009 13:27'!
setUpFields
	product options do: 
		[ :o | 
		| field |
		field := o valueEditor
			label: o name;
			onUpdateOrder: [ :html | self renderTotalOn: html ];
			yourself.
		o required ifTrue: [ field beRequired ].
		form add: field ]! !

!WSEditOrderItem methodsFor: 'accessing' stamp: 'srh 3/13/2009 20:38'!
title
	^'Edit Item'! !

WSComponent subclass: #WSOptionComponent
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSOptionComponent class methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:36'!
option: anOption
	^self basicNew
		initializeWithOption: anOption;
		yourself.! !

!WSOptionComponent methodsFor: 'initialization' stamp: 'srh 5/4/2009 17:37'!
initializeWithOption: anOption
	self initialize.
	option := anOption! !

!WSOptionComponent methodsFor: 'rendering' stamp: 'srh 5/4/2009 17:38'!
renderContentOn: html
	html div: [
		html strong: option name.
		html paragraph: option value]! !

WSComponent subclass: #WSPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSPage methodsFor: 'initialization' stamp: 'StuartHerring 11/16/2009 23:19'!
initialize
	super initialize.! !

WSComponent subclass: #WSProductDetails
	instanceVariableNames: 'product imageViewer customizer editMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductDetails class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/18/2009 19:28'!
edit: aProduct
	^self basicNew
		initializeWithProduct: aProduct customizer: WSEditOrderItem;
		beEditMode;
		yourself.! !

!WSProductDetails class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/17/2009 22:48'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct customizer: WSProductCustomizer
		yourself.! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/18/2009 19:27'!
beEditMode
	editMode := true.! !

!WSProductDetails methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2009 18:10'!
children
	^{imageViewer. customizer}! !

!WSProductDetails methodsFor: 'initialization' stamp: 'StuartHerring 11/18/2009 19:27'!
initializeWithProduct: aProduct customizer: aComponentClass
	self initialize.
	product := aProduct.
	imageViewer := WSProductImageView for: product.
	customizer := aComponentClass product: product.
	customizer onAnswer: [ :a | self answer].
	editMode := false.! !

!WSProductDetails methodsFor: 'rendering' stamp: 'StuartHerring 11/20/2009 19:45'!
renderContentOn: html 
	html div
		class: 'product-details';
		with: 
			[ html render: imageViewer.
			html paragraph: 
				[ html text: '$' , product priceInDollars.
				html space.
			editMode ifFalse: [
				html anchor
				url: self storeUrl;
				with: 'Return to list'] ].
	html paragraph with: product description.
	html render: customizer] 
! !

!WSProductDetails methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 15:15'!
storeUrl
	^(self session baseUrl addToPath: #store)! !

!WSProductDetails methodsFor: 'accessing' stamp: 'srh 4/21/2009 21:10'!
title
	^product name! !

!WSProductDetails methodsFor: 'updating' stamp: 'srh 4/11/2009 13:31'!
updateUrl: aUrl
	aUrl addParameter: #product value: product id.
	super updateUrl: aUrl.
! !

WSComponent subclass: #WSProductImageView
	instanceVariableNames: 'current product id eventTracker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductImageView class methodsFor: 'as yet unclassified' stamp: 'cmd 3/21/2009 17:21'!
for: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2009 20:44'!
goToImage: anImage
	current := anImage! !

!WSProductImageView methodsFor: 'initialization' stamp: 'StuartHerring 3/22/2010 20:53'!
initializeWithProduct: aProduct.
	self initialize.
	product := aProduct.
	current := product preview.
	eventTracker := (WSProductEvent chooseThumbnailForProduct: product).! !

!WSProductImageView methodsFor: 'rendering' stamp: 'StuartHerring 11/24/2009 20:10'!
renderContentOn: html 
	id := html nextId.
	product images ifEmpty: [ ^ self ].
	html div
		id: id;
		class: 'ws-imageViewer';
		with: 
			[ self renderImageViewerOn: html]! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2009 19:49'!
renderImageViewerOn: html
	 html wsImage: current medium.
			html unorderedList: 
				[ (product images do: 
					[ :i | 
					html listItem: 
						[ self renderThumbnailFor: i on: html ] ])]! !

!WSProductImageView methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 19:45'!
renderThumbnailFor: image on: html
	current = image 
		ifTrue: [ html wsImage: image thumbnail ]
		ifFalse: [
			html anchor
				onClick: eventTracker;
				onClick: (html updater id: id; callback: [ :canvas | self goToImage: image. self renderImageViewerOn: canvas ]);
				onClick: 'return false';
				callback: [ self goToImage: image ];
				with: [ html wsImage: image thumbnail]]! !

WSComponent subclass: #WSProductList
	instanceVariableNames: 'products'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductList class methodsFor: 'as yet unclassified' stamp: 'srh 1/2/2009 17:24'!
products: aCollection
	^self basicNew
		products: aCollection;
		initialize.! !

!WSProductList methodsFor: 'accessing' stamp: 'srh 4/10/2009 14:33'!
children
	^products! !

!WSProductList methodsFor: 'accessing' stamp: 'srh 4/10/2009 14:33'!
products: aCollection
	products := (aCollection select: [ :p | p enabled ]) 
		collect: [ :p | WSProductPreview product: p ]
	! !

!WSProductList methodsFor: 'rendering' stamp: 'srh 4/10/2009 14:34'!
renderContentOn: html
	products do: [ :p | html render: p]! !

WSComponent subclass: #WSProductPreview
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductPreview class methodsFor: 'as yet unclassified' stamp: 'srh 4/10/2009 14:36'!
product: aProduct
	^self basicNew 
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductPreview methodsFor: 'initialization' stamp: 'srh 4/10/2009 14:35'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize! !

!WSProductPreview methodsFor: 'rendering' stamp: 'StuartHerring 9/11/2009 18:39'!
renderContentOn: html 
	html div
		class: 'product-preview';
		with: 
			[ html anchor
				class: 'image';
				url: (self urlForProduct: product);
				with: [ product preview ifNotNil: [ html wsImage: product preview preview ] ].
			html heading
				level: 3;
				with: product name	"[
				html anchor url: (self urlForProduct: product); with: product name]".
	html paragraph: 
		[ html text: '$' , product priceInDollars.
		html space.
		html anchor
			url: (self urlForProduct: product);
			with: 'More Details' ].
	html paragraph: product description
	 ].! !

WAComponent subclass: #WSFormElement
	instanceVariableNames: 'rules saveAttempted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSFormElement subclass: #WSDisplayElement
	instanceVariableNames: 'selector recipient label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSDisplayElement class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/15/2009 12:26'!
on: selector of: recipient
	^self basicNew
		initializeWithSelector: selector recipient: recipient;
		yourself.! !

!WSDisplayElement class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/15/2009 12:31'!
value: anObject
	^self basicNew
		initializeWithSelector: #value recipient: [anObject];
		yourself! !

!WSDisplayElement methodsFor: 'initialization' stamp: 'StuartHerring 9/16/2009 13:06'!
initializeWithSelector: aSelector  recipient: anObject 
	self initialize.
	selector := aSelector.
	recipient := anObject.
	label := nil! !

!WSDisplayElement methodsFor: 'accessing' stamp: 'StuartHerring 9/16/2009 13:06'!
label: aLabel
	label := label.! !

!WSDisplayElement methodsFor: 'rendering' stamp: 'StuartHerring 9/15/2009 12:32'!
renderContentOn: html
	html text: self value displayString.! !

!WSDisplayElement methodsFor: 'evaluating' stamp: 'StuartHerring 9/15/2009 12:30'!
value
	^recipient perform: selector! !

WSDisplayElement subclass: #WSImageDisplay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageDisplay methodsFor: 'rendering' stamp: 'StuartHerring 9/15/2009 12:32'!
renderContentOn: html
	|image|
	image := self value.
	html div class: #imageDisplay; with: [
		image ifNotNil: [ html wsImage: image thumbnail ]]! !

WSFormElement subclass: #WSField
	instanceVariableNames: 'value selector receiver tag label description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSField subclass: #WSDropDownField
	instanceVariableNames: 'default list labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSDropDownField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/14/2009 12:57'!
list: aCollection
	^self basicNew
		initializeWithList: aCollection;
		yourself! !

!WSDropDownField methodsFor: 'accessing' stamp: 'srh 6/27/2009 11:10'!
default: aCountryCode
	default := WSCountry byCode: aCountryCode
	! !

!WSDropDownField methodsFor: 'initialization' stamp: 'StuartHerring 9/14/2009 12:55'!
initializeWithList: aList
	self initialize.
	list := aList! !

!WSDropDownField methodsFor: 'accessing' stamp: 'StuartHerring 9/14/2009 15:33'!
labels: aLabelBlock
	labelBlock := aLabelBlock! !

!WSDropDownField methodsFor: 'initialization' stamp: 'srh 6/27/2009 11:22'!
readInitialValue
	value := (receiver perform: selector) ifNil: [default]
! !

!WSDropDownField methodsFor: 'rendering' stamp: 'StuartHerring 11/18/2009 23:45'!
renderContentOn: html 
	html div
		class: self errorClass;
		with: 
			[ | id |
			id := html nextId.
			html label
				for: id;
				with: self label , ':'.
			html select
				list: list;
				selected: value;
				labels: [ :a | a name ];
				callback: [ :v | value := v ].
			description ifNotNil: 
				[ html paragraph
					class: 'desc';
					with: description ] ]! !

WSField subclass: #WSDynamicFieldGroup
	instanceVariableNames: 'visible list labels newItemBlock componentBlock selectedItem editorBlock actionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'StuartHerring 9/18/2009 22:20'!
actions: aBlockClosure 
	actionBlock := aBlockClosure ! !

!WSDynamicFieldGroup methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 13:53'!
addItem: aTemplate
	value add: ((WSTwoStateField for: (self itemForTemplate: aTemplate )) 
			component: componentBlock; 
			editor: editorBlock;
			edit;
			beNew;
			yourself)! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 21:37'!
children
	^value select: [ :i | i isKindOf: WAComponent]! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:41'!
component: aBlock
	componentBlock := aBlock! !

!WSDynamicFieldGroup methodsFor: 'actions' stamp: 'srh 3/9/2009 13:02'!
componentForItem: anItem
	^componentBlock
			ifNil: [ WSDisplayElement value: anItem ]
			ifNotNil: [ componentBlock value: anItem ]! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'StuartHerring 9/16/2009 13:11'!
editor: aBlock
	editorBlock := aBlock! !

!WSDynamicFieldGroup methodsFor: 'initialization' stamp: 'StuartHerring 9/18/2009 22:20'!
initialize
	super initialize.
	value := OrderedCollection new.
	visible := false.
	actionBlock := nil.! !

!WSDynamicFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 23:50'!
itemForTemplate: template
	^newItemBlock 
			ifNil: [ template ]
			ifNotNil: [ newItemBlock value: template ]! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:58'!
labels: aBlock
	labels := aBlock! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 09:46'!
list: anOrderedCollection
	list := OrderedCollection new addAll: anOrderedCollection; yourself! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/9/2009 12:30'!
messages
		| messages |
		messages := OrderedCollection new.
		value do: [:f | messages addAll: f messages ].
		^messages
! !

!WSDynamicFieldGroup methodsFor: 'accessing' stamp: 'srh 3/8/2009 23:40'!
newItem: aBlock 
	newItemBlock := aBlock! !

!WSDynamicFieldGroup methodsFor: 'actions' stamp: 'Stuart Herring 9/18/2009 12:03'!
readInitialValue
	value := ((receiver perform: selector) collect: [ :i | ((WSTwoStateField for: i) 
			component: componentBlock; 
			editor: editorBlock; 
			yourself)]) asOrderedCollection! !

!WSDynamicFieldGroup methodsFor: 'actions' stamp: 'srh 3/8/2009 21:49'!
removeItem: anItem 
	^ value remove: anItem! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'StuartHerring 9/18/2009 22:29'!
renderActionsFor: i on: html 
		html submitButton
			value: 'Remove';
			callback: [ self removeItem: i].
		i editMode ifTrue: [
			html submitButton 
				value: 'Save';
				callback: [ i save ].
			i isNew ifFalse: [
				html submitButton 
					value: 'Cancel Editing';
					callback: [ i cancelEditing ]
			].
			actionBlock ifNotNil:  [ (actionBlock value: i value) do: [ :action |
					html submitButton value: action key;
						callback: action value]].
		] ifFalse: [
			i editable ifTrue: [ html submitButton value: 'Edit'; callback: [ i edit ]]]! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'StuartHerring 12/5/2009 13:42'!
renderContentOn: html 
	html
		fieldSet title: label; legend: label; with: [
			(visible or: [value isEmpty])
				ifTrue: [
					value isEmpty ifFalse: [html submitButton
						callback: [visible := false];
						 value: 'Hide'].
					self renderListOn: html.
					html submitButton value: 'Add';
						callback: [visible := true. self addItem: selectedItem].
					self renderItemsOn: html]
				ifFalse: [html submitButton
						callback: [visible := true];
						 value: 'Show']]! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'StuartHerring 9/16/2009 10:51'!
renderItem: i on: html 
	^ html tableRow: 
		[ html tableData: i.
		html tableData: 
			[ self renderActionsFor: i on: html ] ]! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'Stuart Herring 9/18/2009 12:00'!
renderItemsOn: html 
	value isEmpty ifFalse: 
		[ html table: [ value reverse do: [ :i | 
				self renderItem: i on: html ]]]! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'StuartHerring 9/4/2009 23:12'!
renderListOn: html 
	list ifNotNil: [ | s |
		s := html select.
		s list: list; callback: [:t | selectedItem := t].
		labels ifNotNil: [s labels: labels]]! !

!WSDynamicFieldGroup methodsFor: 'rendering' stamp: 'StuartHerring 9/4/2009 22:48'!
save
	value do: [ :component | component save ].
	receiver perform: selector asMutator with: (value collect: [ :component | component value]).! !

!WSDynamicFieldGroup methodsFor: 'testing' stamp: 'srh 3/9/2009 12:13'!
valid
	^value allSatisfy: [ :i | i valid ]! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 16:21'!
checkbox
	^self basicNew
		tagType:  #checkbox;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/16/2009 14:06'!
fileUpload
	^ WSFileUploadField new! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/17/2009 11:56'!
image
	^WSImageField new! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:28'!
integer
	^WSIntegerField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:57'!
largeText
	^self basicNew
		tagType:  #textArea;
		initialize;
		yourself.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:15'!
money
	^WSMoneyField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:43'!
numeric
	^WSNumericField new.! !

!WSField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:13'!
text
	^self basicNew
		tagType:  #textInput;
		initialize;
		yourself.! !

!WSField methodsFor: 'accessing' stamp: 'StuartHerring 11/18/2009 23:55'!
beRequired
	self addRule: [ :v| v notNil and: [v notEmpty]] withDescription: 'is a required field'.! !

!WSField methodsFor: 'accessing' stamp: 'srh 4/21/2009 21:33'!
description: aDescription
	description := aDescription.! !

!WSField methodsFor: 'rendering' stamp: 'StuartHerring 11/18/2009 23:45'!
errorClass
	^(self saveAttempted not or: [self valid ]) ifFalse: ['error']! !

!WSField methodsFor: 'initialization' stamp: 'StuartHerring 11/18/2009 23:37'!
initialize
	super initialize.! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/26/2009 14:24'!
label
	^label ifNil:[label := selector asCapitalizedPhrase]! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:05'!
label: aString
	label := aString! !

!WSField methodsFor: 'accessing' stamp: 'StuartHerring 9/8/2009 22:09'!
messages
	^ (rules reject: [ :r | r testRule: self value ]) collect: [ :r | self label, ' ', r message ]! !

!WSField methodsFor: 'callbacks' stamp: 'StuartHerring 9/4/2009 20:46'!
on: aSelector of: aReceiver 
	selector := aSelector.
	receiver := aReceiver.
	self readInitialValue! !

!WSField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector! !

!WSField methodsFor: 'rendering' stamp: 'StuartHerring 12/5/2009 12:56'!
renderContentOn: html
	html div class: self errorClass; with: [
		| id |
		id := html nextId.
		html label for: id; with: self label, ':'.
		(html perform: tag) 
			id: id;
			callback: [ :v| value := v];
			title: label;
			value: value.
		description ifNotNil: [html paragraph class: 'desc'; with: description]]! !

!WSField methodsFor: 'actions' stamp: 'srh 6/26/2009 20:23'!
save
	receiver perform: selector asMutator with: self value! !

!WSField methodsFor: 'accessing' stamp: 'srh 12/30/2008 17:01'!
tagType: symbol
	tag := symbol! !

!WSField methodsFor: 'testing' stamp: 'srh 6/26/2009 20:24'!
valid
	^rules allSatisfy: [ :r | r  testRule: self value ].! !

!WSField methodsFor: 'accessing' stamp: 'srh 1/1/2009 20:55'!
value
	^value! !

WSField subclass: #WSFileUploadField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSFileUploadField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/16/2009 14:10'!
new
	^self basicNew
		tagType: #fileUpload;
		initialize;
		yourself.! !

!WSFileUploadField methodsFor: 'accessing' stamp: 'StuartHerring 9/17/2009 11:16'!
beRequired
	"Can't make FileUpload required - needs to be handled at the form level"! !

!WSFileUploadField methodsFor: 'initialization' stamp: 'StuartHerring 9/16/2009 14:09'!
readInitialValue
	"Can't do anything useful here"! !

!WSFileUploadField methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 11:35'!
save
	value ifNotNil: [ super save]! !

WSField subclass: #WSImageField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageField methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 19:09'!
beRequired
	self addRule: [ :v| v notNil] withDescription: 'is a required field'.! !

!WSImageField methodsFor: 'rendering' stamp: 'StuartHerring 12/5/2009 13:44'!
renderContentOn: html
	html div class: self errorClass; with: [
		| id |
		id := html nextId.
		html label for: id; with: self label, ':'.
		html fileUpload 
			id: id;
			title: label;
			callback: [ :v| self setValue: v].
		value ifNotNil: [html wsImage: value thumbnail]].
	description ifNotNil: [html paragraph class: 'desc'; with: description].
	! !

!WSImageField methodsFor: 'private' stamp: 'StuartHerring 9/17/2009 11:54'!
setValue: aWAFile
	aWAFile ifNotNil: [
		value := WSImage fromStream: (ReadStream on: aWAFile contents asByteArray)]! !

WSField subclass: #WSIntegerField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSIntegerField class methodsFor: 'as yet unclassified' stamp: 'srh 12/31/2008 10:24'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2010 11:02'!
initialize
	super initialize.
	self
		addRule: [:v | v isNil
				or: [(Number readFrom: v ifFail: [ nil ]) isInteger]] "Nil will fail the #isInteger test"
		withDescription: 'must be a whole number'.! !

!WSIntegerField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := value printString ]! !

!WSIntegerField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: value asInteger! !

WSField subclass: #WSMoneyField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSMoneyField class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 18:18'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSMoneyField methodsFor: 'initialization' stamp: 'srh 3/8/2009 21:43'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := (value / 100) asFloat printString ]! !

!WSMoneyField methodsFor: 'actions' stamp: 'srh 3/9/2009 12:13'!
save
	receiver perform: selector asMutator with: ((value asNumber) * 100) asInteger! !

WSField subclass: #WSNumericField
	instanceVariableNames: 'zeroIsNil'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSNumericField class methodsFor: 'as yet unclassified' stamp: 'srh 3/11/2009 14:42'!
new
	^self basicNew
		tagType: #textInput;
		initialize;
		yourself.! !

!WSNumericField methodsFor: 'initialization' stamp: 'StuartHerring 11/8/2010 22:07'!
beRequired
	self addRule: [ :v| 
		v notNil and: [
		v notEmpty	and: [
		[(zeroIsNil and: [(Number readFrom: v ifFail: [0]) = 0]) not] on: Error do: [true]]]]		
	withDescription: 'is a required field'.! !

!WSNumericField methodsFor: 'initialization' stamp: 'StuartHerring 9/8/2009 21:35'!
beZeroIsNil
	zeroIsNil := true.! !

!WSNumericField methodsFor: 'initialization' stamp: 'StuartHerring 11/9/2010 22:06'!
initialize
	super initialize.
	zeroIsNil := false.
	self
		addRule: [:v | v isEmptyOrNil
				or: [(Number readFrom: v ifFail: [nil]) isNumber]]
		withDescription: 'must be a number'.! !

!WSNumericField methodsFor: 'initialization' stamp: 'StuartHerring 9/8/2009 21:54'!
readInitialValue
	value := receiver perform: selector.
	value ifNotNil: [ value := (value > 0 or: [ zeroIsNil not ]) ifTrue: [value printString] ifFalse: [nil]]! !

!WSNumericField methodsFor: 'actions' stamp: 'srh 3/11/2009 14:43'!
save
	receiver perform: selector asMutator with: value asNumber! !

WSFormElement subclass: #WSFieldGroup
	instanceVariableNames: 'fields label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:40'!
add: aField
	fields add: aField! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 11/19/2009 00:24'!
beforeSave
	super beforeSave.
	fields do: [:f | f beforeSave].
! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:49'!
children
	^fields! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 9/15/2009 14:24'!
initialize
	super initialize.
	fields := OrderedCollection new.! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:47'!
label
	^label! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:47'!
label: aString
	label := aString! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 11/18/2009 22:38'!
messages
	| messages |
	messages := OrderedCollection new.
	fields do: [ :f | messages addAll: f messages ].
	^messages! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:54'!
readInitialValue
	fields do: [ :f | f readInitialValue ]! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 12/5/2009 13:41'!
renderContentOn: html
			html fieldSet 
				legend: label;
				title: label;
				with: [ fields do: [:f | html render: f]]! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 11/19/2009 00:52'!
save
	self beforeSave.
	^self valid 
		ifTrue: [ fields do: [:f | f save]. true]
		ifFalse: [ false ]! !

!WSFieldGroup methodsFor: 'adding' stamp: 'StuartHerring 8/30/2009 13:54'!
valid
	^(fields allSatisfy: [:f | f valid]) and: [rules allSatisfy: [:r | r testRule: self]]! !

WSFieldGroup subclass: #WSForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSForm methodsFor: 'accessing' stamp: 'StuartHerring 11/7/2009 09:44'!
messages
	^ (rules reject: [ :r | r testRule: self ]) collect: [ :r | self label, ' ', r message ]! !

!WSForm methodsFor: 'rendering' stamp: 'StuartHerring 11/19/2009 00:06'!
renderContentOn: html
	html div class: #form; with: [
		self renderMessagesOn: html.
		fields do: [:f | html render: f]].
! !

!WSForm methodsFor: 'rendering' stamp: 'StuartHerring 11/19/2009 00:22'!
renderMessagesOn: html 
	(self saveAttempted and: [self valid not ]) 
		ifTrue: [| messages |
			messages := OrderedCollection new.
			messages addAll: self messages.
			fields do: [ :f | messages addAll: f messages ].
			html div class: 'error-msgs'; with: [
				html paragraph: 'Please correct the following problems before continuing'.
				html unorderedList: [ messages do: [ :m | html listItem: m ]]]].! !

WSForm subclass: #WSOptionField
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOptionField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/3/2009 22:10'!
option: anOptionTemplate
	^self basicNew
		initializeWithOption: anOptionTemplate;
		yourself! !

!WSOptionField methodsFor: 'initialization' stamp: 'StuartHerring 9/3/2009 22:11'!
initializeWithOption: anOptionTemplate
	self initialize.
	option := anOptionTemplate.
	self add: (WSLabel label: option class label).
	self add: (WSField text label: 'Name'; on: #name of: option; beRequired; yourself).
	self add: (WSField checkbox label: 'Required'; on: #required of: option; yourself).! !

!WSOptionField methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:21'!
value
	^option! !

WSForm subclass: #WSOptionValueEditor
	instanceVariableNames: 'option updateBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSOptionValueEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/20/2009 19:55'!
option: anOption
	^self basicNew
		initializeWithOption: anOption;
		yourself! !

!WSOptionValueEditor methodsFor: 'initialization' stamp: 'StuartHerring 11/20/2009 19:59'!
initializeWithOption: anOption
	self initialize.
	option := anOption.! !

!WSOptionValueEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2009 13:28'!
onUpdateOrder: aBlock
	updateBlock := aBlock.! !

!WSOptionValueEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2009 11:21'!
price
	"Returns the current selected price of the option"
	^0! !

!WSOptionValueEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/24/2009 13:28'!
updateOrderOn: html
	updateBlock ifNotNil: [ updateBlock value: html]! !

WSOptionValueEditor subclass: #WSSimpleOptionValueEditor
	instanceVariableNames: 'description value selector receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSSimpleOptionValueEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/20/2009 20:05'!
beRequired
	" Dosen't make sense"! !

!WSSimpleOptionValueEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/20/2009 20:06'!
description: aDescription
	description := aDescription.! !

!WSSimpleOptionValueEditor methodsFor: 'initialization' stamp: 'StuartHerring 11/20/2009 20:01'!
initializeWithOption: aSimpleOption
	super initializeWithOption: aSimpleOption.
	self on: #enabled of: aSimpleOption.
	self description: aSimpleOption description! !

!WSSimpleOptionValueEditor methodsFor: 'adding' stamp: 'StuartHerring 11/20/2009 20:05'!
label
	^label ifNil:[label := selector asCapitalizedPhrase]! !

!WSSimpleOptionValueEditor methodsFor: 'callbacks' stamp: 'StuartHerring 11/20/2009 20:04'!
on: aSelector of: aReceiver 
	selector := aSelector.
	receiver := aReceiver.
	self readInitialValue! !

!WSSimpleOptionValueEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2009 10:05'!
price
	^value 
		ifTrue: [ option price ]
		ifFalse: [ 0 ]! !

!WSSimpleOptionValueEditor methodsFor: 'adding' stamp: 'StuartHerring 11/24/2009 10:03'!
readInitialValue
	value := (receiver perform: selector) ifNil: [ false].! !

!WSSimpleOptionValueEditor methodsFor: 'rendering' stamp: 'StuartHerring 11/24/2009 14:27'!
renderContentOn: html
	html fieldSet class: 'ws-simpleOption'; legend: option name;
	with: [
		self renderSelectorOn: html.
		option price > 0 ifTrue: [
			html paragraph: '$', option priceInDollars].
		html paragraph: description.
	]

! !

!WSSimpleOptionValueEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 22:33'!
renderSelectorOn: html
	|id|
	id := html nextId.
	html div: [
		option image ifNotNil: [html wsImage onClick: ('$("{1}").click();' format: {id}); image: option image preview].
		html checkbox 
			id: id;
			onClick: (html updater id: 'ws-orderTotal'; 
					callback: [ :canvas  | value := value not. self updateOrderOn: canvas]);
			callback: [ :v| value := v];
			value: value].
! !

!WSSimpleOptionValueEditor methodsFor: 'actions' stamp: 'StuartHerring 11/20/2009 20:04'!
save
	receiver perform: selector asMutator with: self value! !

!WSSimpleOptionValueEditor methodsFor: 'adding' stamp: 'StuartHerring 11/20/2009 20:06'!
valid
	^true! !

!WSSimpleOptionValueEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/20/2009 20:06'!
value
	^value! !

WSForm subclass: #WSOrderCustomizationForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSOrderCustomizationForm methodsFor: 'accessing' stamp: 'StuartHerring 11/21/2009 11:21'!
fields
	^fields! !

!WSOrderCustomizationForm methodsFor: 'rendering' stamp: 'StuartHerring 11/19/2009 00:16'!
renderMessagesOn: html 
	(self saveAttempted and: [self valid not]) 
		ifTrue: [| messages |
			messages := OrderedCollection new.
			messages addAll: self messages.
			fields do: [ :f | messages addAll: f messages ].
			html div class: 'error-msgs'; with: [ 
				html paragraph: 'There are one or more problems with your order'.
				html unorderedList with: [ messages do: [ :m | html listItem: m ]]]]! !

WSForm subclass: #WSSimpleOptionEditor
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSSimpleOptionEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 23:38'!
option: anOptionTemplate
	^self basicNew
		initializeWithOption: anOptionTemplate;
		yourself! !

!WSSimpleOptionEditor methodsFor: 'initialization' stamp: 'StuartHerring 11/19/2009 23:44'!
initializeWithOption: anOptionTemplate
	self initialize.
	option := anOptionTemplate.
	self add: (WSLabel label: option class label).
	self add: (WSField text label: 'Name'; on: #name of: option; beRequired; yourself).
	self add: (WSField largeText label: 'Description'; on: #description of: option; yourself).
	self add: (WSField integer label: 'Price'; on: #optionPrice of: option; yourself).
	self add: (WSImageField new on: #image of: option; yourself)! !

!WSSimpleOptionEditor methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:38'!
value
	^option! !

!WSFormElement methodsFor: 'adding' stamp: 'StuartHerring 9/8/2009 21:47'!
addRule: aBlock withDescription: desc.
	rules add: (WSRule rule: aBlock message: desc)! !

!WSFormElement methodsFor: 'adding' stamp: 'StuartHerring 11/18/2009 23:51'!
beforeSave
	saveAttempted := true.! !

!WSFormElement methodsFor: 'adding' stamp: 'StuartHerring 11/18/2009 23:38'!
initialize
	super initialize.
	rules := OrderedCollection new.
	saveAttempted := false.! !

!WSFormElement methodsFor: 'accessing' stamp: 'srh 3/8/2009 22:27'!
messages
	^#()! !

!WSFormElement methodsFor: 'actions' stamp: 'StuartHerring 11/18/2009 23:38'!
save
	saveAttempted := true.! !

!WSFormElement methodsFor: 'accessing' stamp: 'StuartHerring 11/18/2009 23:51'!
saveAttempted
	^saveAttempted! !

!WSFormElement methodsFor: 'testing' stamp: 'srh 3/8/2009 22:21'!
valid
	^true! !

WSFormElement subclass: #WSLabel
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLabel class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 22:23'!
label: aLabel
	^self basicNew
		initializeWithLabel: aLabel;
		yourself! !

!WSLabel methodsFor: 'initialization' stamp: 'srh 3/8/2009 22:25'!
initializeWithLabel: aLabel 
	self initialize.
	label := aLabel! !

!WSLabel methodsFor: 'rendering' stamp: 'srh 3/8/2009 22:23'!
renderContentOn: html 
	html label: label! !

WSFormElement subclass: #WSTwoStateField
	instanceVariableNames: 'componentBlock value editMode editorBlock component new'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSTwoStateField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/16/2009 13:24'!
for: anObject
	^self basicNew
		initializeWithValue: anObject;
		yourself! !

!WSTwoStateField methodsFor: 'new/old' stamp: 'StuartHerring 9/17/2009 13:53'!
beNew
	new := true.! !

!WSTwoStateField methodsFor: 'actions' stamp: 'Stuart Herring 9/18/2009 11:57'!
cancelEditing
	self viewable ifTrue: [
	component := componentBlock value: value.
		editMode := false] ifFalse: [ self edit ]
! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'Stuart Herring 9/18/2009 11:50'!
children 
	^Array with: self component! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'Stuart Herring 9/18/2009 11:52'!
component
	component ifNil: [ self editMode ifTrue: [ self edit] ifFalse: [self cancelEditing]].
	^component! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'StuartHerring 9/16/2009 13:57'!
component: aBlockClosure 
	componentBlock := aBlockClosure.
	editMode ifFalse: [self cancelEditing ]! !

!WSTwoStateField methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 20:08'!
edit
	self editable ifTrue: [
		component := editorBlock value: value.
		editMode := true]! !

!WSTwoStateField methodsFor: 'as yet unclassified' stamp: 'Stuart Herring 9/18/2009 11:51'!
editMode
	^editMode or: [componentBlock isNil and: [editorBlock notNil]]! !

!WSTwoStateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/16/2009 13:21'!
editable
	^editorBlock notNil! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'StuartHerring 9/16/2009 13:57'!
editor: aBlockClosure 
	editorBlock := aBlockClosure.
	editMode ifTrue: [ self edit ].! !

!WSTwoStateField methodsFor: 'initialization' stamp: 'StuartHerring 9/17/2009 14:54'!
initializeWithValue: anObject
	self initialize.
	value := anObject.
	editMode := false.
	new := false.! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'StuartHerring 9/17/2009 13:53'!
isNew
	^new! !

!WSTwoStateField methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 13:55'!
save
	(editMode and: [component valid]) ifTrue: [
		component save.
		value := component value.
		self cancelEditing.
		new := false.
	]! !

!WSTwoStateField methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 12:20'!
valid
	^editMode not or: [ component valid]! !

!WSTwoStateField methodsFor: 'accessing' stamp: 'StuartHerring 9/17/2009 11:49'!
value
	^value! !

!WSTwoStateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/17/2009 20:07'!
viewable
	^componentBlock isNil not! !

WAComponent subclass: #WSIPNListener
	instanceVariableNames: 'fields response url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:46'!
createUrlFor: aRequest
	url := WAUrl new.
	url scheme: #http. "http for now due to lack of SSL support in Squeak. Need to use stunnel to achieve https"
	url addToPath: '/us/cgi-bin/webscr'.
	url hostname: (self preferenceAt: #paypalIPNHost).
	url addParameter: 'cmd' value: '_notify-validate'.
	fields keysAndValuesDo: [ :key :value  | url addParameter: key value: value]! !

!WSIPNListener methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:47'!
doIPNRequest: aRequest
	self createUrlFor: aRequest.
	response := url displayString asUrl retrieveContents.! !

!WSIPNListener methodsFor: 'request processing' stamp: 'srh 7/9/2009 19:56'!
initialRequest: aRequest
	fields := aRequest fields.
	self doIPNRequest: aRequest.! !

!WSIPNListener methodsFor: 'rendering' stamp: 'srh 7/13/2009 17:52'!
renderContentOn: html
	html div style: 'background-color: white'; with: [
	html heading: 'IPN Listener'.
	html heading level: 2; with: 'Parameters'.
	fields keysAndValuesDo: [ :key :value |
		html paragraph: key displayString, ' -> ', value displayString]].
	html heading level: 2; with: 'Url'.
	html paragraph: url displayString.
	html heading level: 2; with: 'Response'.
	html paragraph: response contents.! !

WAComponent subclass: #WSImageEditor
	instanceVariableNames: 'value imageField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
image: anImage
	^self basicNew
		initializeWithImage: anImage;
		yourself.! !

!WSImageEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:54'!
new
	^self image: nil! !

!WSImageEditor methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:57'!
children
	^Array with: imageField! !

!WSImageEditor methodsFor: 'initialization' stamp: 'StuartHerring 9/17/2009 14:13'!
initializeWithImage: anImage
	self initialize.
	value := anImage.
	imageField := WSField image
		label: 'Select an Image';
		on: #value of: self;
		yourself.
! !

!WSImageEditor methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 14:14'!
save
	imageField valid ifTrue: [imageField save]! !

!WSImageEditor methodsFor: 'testing' stamp: 'StuartHerring 9/17/2009 14:11'!
valid
	^imageField valid! !

!WSImageEditor methodsFor: 'accessing' stamp: 'StuartHerring 9/17/2009 14:12'!
value
	^value! !

!WSImageEditor methodsFor: 'accessing' stamp: 'StuartHerring 9/17/2009 14:13'!
value: anObject
	value := anObject! !

WAComponent subclass: #WSMessageHistory
	instanceVariableNames: 'messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSMessageHistory class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:52'!
messages: aCollection
	^self basicNew
		initializeWithMessages: aCollection;
		yourself! !

!WSMessageHistory methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 21:51'!
initializeWithMessages: aCollection 
	self initialize.
	messages := aCollection! !

!WSMessageHistory methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 21:51'!
renderContentOn: html 
	html div: 
		[ messages do: 
			[ :m | 
			self 
				renderMessage: m
				on: html ] ]! !

!WSMessageHistory methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 16:22'!
renderMessage: m on: html
	html definitionList: [
		html definitionTerm: 'Date: '.
		html definitionData: m date displayString.
		html definitionTerm: 'To: '.
		html definitionData: m recipient.
		html definitionTerm: 'Subject: '.
		html definitionData: m subject.
		html definitionTerm: 'Message'.
		html definitionData: m message.
	]! !

WAComponent subclass: #WSOrderCancel
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderCancel class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 23:52'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderCancel methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 23:53'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
	(WSCancelOrderCommand order: order reason: 'User cancelled payment') run.! !

!WSOrderCancel methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 23:52'!
renderContentOn: html
	html heading: 'Order Cancelled'.
	html paragraph: 'Your order was cancelled'.
	html div class: 'nav-buttons'; with: [
		html anchor callback: [self answer]; with: 'Close']! !

WAComponent subclass: #WSOrderDetails
	instanceVariableNames: 'order history currentItem options messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderDetails class methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:11'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderDetails methodsFor: 'accessing' stamp: 'srh 5/4/2009 17:53'!
children
	^Array with: history with: options.! !

!WSOrderDetails methodsFor: 'accessing' stamp: 'srh 5/2/2009 11:43'!
currentItem
	^currentItem! !

!WSOrderDetails methodsFor: 'accessing' stamp: 'srh 5/4/2009 17:55'!
currentItem: anItem
	currentItem := anItem.
	options := WSOrderOptionDetails item: anItem! !

!WSOrderDetails methodsFor: 'initialization' stamp: 'StuartHerring 9/11/2009 15:52'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
	self currentItem: order items first.
	history := WSOrderHistory order: anOrder.
	messages := WSMessageHistory messages: anOrder messages.! !

!WSOrderDetails methodsFor: 'rendering' stamp: 'srh 4/27/2009 12:13'!
renderActionsOn: html
	html div: [
		html anchor callback: [self answer]; with: 'Done']! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:18'!
renderAddress: address on: html 
	html text: address name; break.
	html text: address address1; break.
	address address2 ifNotEmpty: [ html text: address address2; break ].
	html text: address locality; space; text: address state; space; text: address postcode; break.
	html text: address country name.! !

!WSOrderDetails methodsFor: 'rendering' stamp: 'srh 6/13/2009 16:23'!
renderContentOn: html
	self renderActionsOn: html.
	self renderCustomerDetailsOn: html.
	self renderHistoryOn: html.
	self renderOrderOn: html.
	self renderDetailsOn: html.
	self renderMessagesOn: html.! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 10:06'!
renderCustomerDetailsOn: html 
	html fieldSet
		class: 'customerDetails';
		with: 
			[ html legend: 'Customer Details'.
			html definitionList: 
				[ html definitionTerm: 'Name'.
				html definitionData: order customer name.
				html definitionTerm: 'Email'.
				html definitionData: order customer email.
				html definitionTerm: 'Ship To'.
				html definitionData: 
					[ self renderAddress: order address on: html ] ] ]! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 18:00'!
renderDetailsOn: html
	html fieldSet: [
		html legend: 'Details - ', currentItem name.
		html render: options].! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:28'!
renderHistoryOn: html
	html fieldSet class: 'history';with: [
		html legend: 'History'.
		html render: history]! !

!WSOrderDetails methodsFor: 'rendering' stamp: 'srh 6/13/2009 16:24'!
renderMessagesOn: html
	html fieldSet class: 'messages';with: [
		html legend: 'Message Log'.
		html render: messages]! !

!WSOrderDetails methodsFor: 'as yet unclassified' stamp: 'srh 5/2/2009 11:42'!
renderOrderOn: html
	html form: [
	html fieldSet: [
		html legend: 'Items'.
		html select size: 5; 
			beSubmitOnChange; 
			list: order items;
			on: #currentItem of: self;
			labels: [ :i | i name ]]]! !

WAComponent subclass: #WSOrderErrorPage
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderErrorPage class methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 10:30'!
error: anException
	^self basicNew
		error: anException;
		initialize;
		yourself.! !

!WSOrderErrorPage methodsFor: 'accessing' stamp: 'srh 1/3/2009 10:30'!
error: anException
	error := anException! !

!WSOrderErrorPage methodsFor: 'rendering' stamp: 'srh 1/4/2009 20:52'!
renderContentOn: html
	html heading: 'Order Failed'.
	html paragraph: 'An error ocurred while processing your order: ', error printString.
	html div class: 'nav-buttons'; with: [ html anchor callback: [self answer]; with: 'Back']! !

WAComponent subclass: #WSOrderHistory
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderHistory class methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:30'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderHistory methodsFor: 'initialization' stamp: 'srh 4/27/2009 12:30'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder! !

!WSOrderHistory methodsFor: 'rendering' stamp: 'srh 4/27/2009 12:39'!
renderContentOn: html.
	html table: [
		html tableRow: [ html tableHeading: 'Date'; tableHeading: 'Status'; tableHeading: 'Details' ].
		order history do: [ :s |
			self renderStatus: s on: html]]! !

!WSOrderHistory methodsFor: 'as yet unclassified' stamp: 'srh 4/27/2009 12:36'!
renderStatus: aStatus on: html
	html tableRow: [
		html tableData: aStatus date displayString.
		html tableData: aStatus name asCapitalizedPhrase.
		html tableData: aStatus details]! !

WAComponent subclass: #WSOrderOptionDetails
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSOrderOptionDetails class methodsFor: 'as yet unclassified' stamp: 'srh 5/4/2009 17:56'!
item: anItem
	^self basicNew
		initializeWithItem: anItem;
		yourself.! !

!WSOrderOptionDetails methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 20:20'!
children
	^options collect: [ :association | association value ].! !

!WSOrderOptionDetails methodsFor: 'initialization' stamp: 'StuartHerring 11/19/2009 20:20'!
initializeWithItem: anItem
	self initialize.
	options := anItem options collect: [ :o | o->o asComponent].! !

!WSOrderOptionDetails methodsFor: 'rendering' stamp: 'StuartHerring 11/19/2009 20:21'!
renderContentOn: html
	html definitionList: [
		options do: [ :association |
			html 
				definitionTerm: association key name;
				definitionData: association value ]]! !

WAComponent subclass: #WSOrderSuccess
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSOrderSuccess class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 14:31'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder;
		yourself! !

!WSOrderSuccess methodsFor: 'initialization' stamp: 'srh 3/9/2009 11:13'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
! !

!WSOrderSuccess methodsFor: 'rendering' stamp: 'StuartHerring 9/6/2009 23:36'!
renderContentOn: html
	html heading: 'Order Complete'.
	html paragraph: 'Your order was succesfully placed, and your reference number is: ', order reference.
	html div class: 'nav-buttons'; with: [
		html anchor callback: [self answer]; with: 'Close']! !

WAComponent subclass: #WSPayPalCheckout
	instanceVariableNames: 'order onSuccess onCancel url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/21/2009 17:18'!
new
	^self shouldNotImplement! !

!WSPayPalCheckout class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 16:51'!
order: anOrder
	^self basicNew
		initializeWithOrder: anOrder
		yourself.! !

!WSPayPalCheckout methodsFor: 'initialization' stamp: 'StuartHerring 9/8/2009 07:59'!
initializeUrl
	url := WAUrl new.
	url scheme: #http.
	url addToPath: '/us/cgi-bin/webscr'.
	url hostname: (self preferenceAt: #paypalHost).
	url addParameter: 'business' value: (self preferenceAt: #accountEmail)! !

!WSPayPalCheckout methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 23:56'!
initializeWithOrder: anOrder
	order := anOrder.
	onSuccess := [self answer: (self call: (WSOrderSuccess order: order))].
	onCancel := [self answer: (self call: (WSOrderCancel order: order))].
	self initializeUrl.
	self initialize.! !

!WSPayPalCheckout methodsFor: 'accessing' stamp: 'srh 2/24/2009 20:51'!
onCancel: aBlock
	onCancel := aBlock.! !

!WSPayPalCheckout methodsFor: 'accessing' stamp: 'srh 2/22/2009 16:52'!
onSuccess: aBlock
	onSuccess := aBlock.! !

!WSPayPalCheckout methodsFor: 'as yet unclassified' stamp: 'StuartHerring 12/6/2009 14:57'!
prepareUrlOn: html
	url addParameter: 'cmd' value: '_cart'.
	url addParameter: 'upload' value: '1'.
	url addParameter: 'address_override' value: '1'.
	url addParameter: 'business' value: (self preferenceAt: #accountEmail).
	url addParameter: 'currency_code' value: 'AUD'.
	url addParameter: 'first_name' value: (order customer name findTokens: ' ') first.
	url addParameter: 'last_name' value: (order customer name findTokens: ' ') last.
	url addParameter: 'address1' value: order address address1.
	url addParameter: 'address2' value: order address address2.
	url addParameter: 'city' value: order address locality.
	url addParameter: 'state' value: order address state.
	url addParameter: 'zip' value: order address postcode.
	url addParameter: 'country' value: order address country code.
	url addParameter: 'rm' value: '2'.
	url addParameter: 'return' value: (html urlForAction: onSuccess).
	url addParameter: 'cancel_return' value: (html urlForAction: onCancel).
"	url addParameter: 'shipping' value: (order shippingInDollars)."
	order inject: 1 into: [:index :product|
		url addParameter: 'amount_', index printString value: product totalInDollars.
		url addParameter: 'item_name_', index printString value: product name.
	index + 1].
	url addParameter: 'amount_', (order items size + 1) printString value: (order shippingInDollars).
	url addParameter: 'item_name_', (order items size  + 1 ) printString  value: 'Shipping'.
! !

!WSPayPalCheckout methodsFor: 'rendering' stamp: 'srh 2/24/2009 21:26'!
renderContentOn: html
	self prepareUrlOn: html.
	self session redirectTo: url displayString.! !

WAComponent subclass: #WSProductEditor
	instanceVariableNames: 'product fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/4/2009 23:55'!
copyOf: aProduct
	^self product: aProduct asTemplate	! !

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'srh 2/5/2009 20:49'!
new
	^self product: (WSProduct new).! !

!WSProductEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/4/2009 23:46'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductEditor methodsFor: 'accessing' stamp: 'srh 1/1/2009 15:19'!
children
	^Array with: fields! !

!WSProductEditor methodsFor: 'initialization' stamp: 'srh 2/5/2009 20:47'!
initializeWithProduct: aProduct
	self initialize.
	product := aProduct.
	self setupFields.! !

!WSProductEditor methodsFor: 'rendering' stamp: 'StuartHerring 9/16/2009 10:36'!
renderContentOn: html
	html form multipart with: [
		html render: fields.
		html div: [
			html cancelButton value: 'Cancel'; callback: [ self answer: nil].
			html submitButton value: 'Save'; callback: [ self saveAndAnswer]
	]]! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 01:04'!
saveAndAnswer
	(WSApplyFormCommand form: fields) run 
		ifTrue: [self answer: product]! !

!WSProductEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/18/2009 22:19'!
setupFields
	fields := WSForm new.
	fields add: (WSField text
			label: 'Name';
			on: #name
				of: product;
			beRequired).
	fields add: (WSField money
			label: 'Price';
			on: #price
				of: product;
			beRequired).
	fields add: (WSField largeText
			label: 'Description';
			on: #description
				of: product).
	fields add: (WSDynamicFieldGroup new
			label: 'Images';
			newItem: [ :x | WSImage new ];
			editor: [ :image | WSImageEditor image: image ];
			actions: [ :i | product preview = i ifFalse: [ { 'Set as Preview' -> [ product preview: i ]}] ifTrue: [#()]];
			component: [ :image | WSImageDisplay on: #value of: [image] ];
			on: #images of: product;
			yourself).
	fields add: (WSDynamicFieldGroup new
			label: 'Product Specific Fields';
			list: WSOption subclasses;
			labels: [ :item | item label ];
			newItem: [ :template | template new ];
			editor: [ :item | item editor ];
			on: #options
				of: product;
			yourself)! !

WAComponent subclass: #WSRoot
	instanceVariableNames: 'cartWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/16/2009 23:20'!
addToCart: aWSAddToCart 
	self session cart add: aWSAddToCart product! !

!WSRoot methodsFor: 'initialization' stamp: 'StuartHerring 11/16/2009 22:51'!
initialize
	super initialize.
	self initializeCart.! !

!WSRoot methodsFor: 'initialization' stamp: 'StuartHerring 11/9/2010 20:17'!
initializeCart
	cartWidget := WSCartWidget new.
	self session on: WSEmptyCart do: [ :a | self resetCart ].
	self session on: WSAddToCart do: [ :a | self addToCart: a ].
	self session on: WSReviewCart do: [:a | self reviewCart: a ].! !

!WSRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/9/2010 20:30'!
resetCart
	self session resetCart! !

!WSRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/9/2010 20:30'!
reviewCart: aWSReviewCart
	self session announce: (WSOpenDialogue component: (WSCartViewDialog cart: aWSReviewCart cart)).
! !

WAComponent subclass: #WSStoreAdmin
	instanceVariableNames: 'store'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSStoreAdmin class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 11:51'!
canBeRoot
	^true! !

!WSStoreAdmin class methodsFor: 'as yet unclassified' stamp: 'srh 3/30/2009 13:37'!
isDeployed
	^true! !

!WSStoreAdmin methodsFor: 'initialization' stamp: 'srh 1/24/2009 21:57'!
initialize
	super initialize.
	store := self session store.! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:19'!
manageOrders
	self call: (WSOrderManager store: store)! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 21:18'!
manageProducts
	self call: (WSProductManager store: store) ! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 1/3/2009 09:49'!
menu: title callback: aBlock on: html
	html heading level: 2; with: [
	html anchor 
		callback: aBlock; 
		with: title].
! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 5/28/2009 16:14'!
migrateStore
	self session magmaSession commit: [store migrate].
	self inform: 'Migration Successful'! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2009 13:23'!
renderConfigurationOn: html 
	html fieldSet
		legend: 'Configuration';
		with: [ 
			self menu: 'Store Configuration'
				callback: [self storeConfiguration]
				on: html.
			WSOptionAdminPage allPages do: [ :each |
				self menu: each label
				callback: [self call: (each store: store)]
				on: html ]]! !

!WSStoreAdmin methodsFor: 'rendering' stamp: 'srh 7/19/2009 15:28'!
renderContentOn: html 
	html div id: 'home';
		with: [self renderStoreManagementOn: html.
			self renderReportsOn: html.
			self renderConfigurationOn: html.
			self renderSystemMaintenanceOn: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:55'!
renderReportsOn: html 
	html fieldSet
		legend: 'Reports';
		with: [
			self menu: 'IPN Log' callback: [ self showIPNLog ] on: html.
			self menu: 'Message Log' callback: [ self showMessageLog ] on: html.		

		 ]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:25'!
renderStoreManagementOn: html 
	html fieldSet legend: 'Manage Store';
		with: [self
				menu: 'Manage Products'
				callback: [self manageProducts]
				on: html.
			self
				menu: 'Manage Orders'
				callback: [self manageOrders]
				on: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:27'!
renderSystemMaintenanceOn: html 
	html fieldSet legend: 'System Maintenance';
		with: [self
				menu: 'Migrate Store'
				callback: [self migrateStore]
				on: html.
			self
				menu: 'Reset Store'
				callback: [self resetStore]
				on: html]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 3/1/2009 18:58'!
resetStore
	(self confirm: 'This will Delete the entire store and cannot be undone - are you sure?') ifTrue: [
		self session magmaSession commit: [ self session magmaSession root at: #store put: WSStore new]]! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 7/19/2009 15:45'!
showIPNLog
	self call: (WSIPNLog store: store)! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:54'!
showMessageLog
	self call: (WSMessageLog store: store)! !

!WSStoreAdmin methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:44'!
storeConfiguration
	self call: (WSStoreConfiguration store: store) ! !

WAComponent subclass: #WSStoreConfiguration
	instanceVariableNames: 'form store settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSStoreConfiguration class methodsFor: 'as yet unclassified' stamp: 'srh 8/4/2009 19:30'!
store: aStore
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSStoreConfiguration methodsFor: 'accessing' stamp: 'srh 8/4/2009 19:32'!
children
	^Array with: form! !

!WSStoreConfiguration methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 20:32'!
initializeFormFields
	form := WSForm new.
	settings byGroup keysAndValuesDo: [ :group :list |
		| fg |
		fg := WSFieldGroup new label: group asCapitalizedPhrase.
		form add: fg.
		list do: [ :s | fg add: s editField]]! !

!WSStoreConfiguration methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 12:13'!
initializeWithStore: aStore 
	self initialize.
	settings := aStore settings.
	self initializeFormFields! !

!WSStoreConfiguration methodsFor: 'rendering' stamp: 'srh 8/15/2009 10:07'!
renderContentOn: html
	html heading: 'Store Configuration'.
	html form: [
		html render: form.
		html cancelButton callback: [ self answer ]; value: 'Cancel'.
		html submitButton callback: [ self save ]; value: 'Save'.
	]! !

!WSStoreConfiguration methodsFor: 'actions' stamp: 'StuartHerring 11/19/2009 01:20'!
save
	(WSApplyFormCommand form: form) run
		ifTrue: [self answer]! !

WAComponent subclass: #WSWizardPage
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

WSWizardPage subclass: #WSCartViewPage
	instanceVariableNames: 'cartView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCartViewPage methodsFor: 'accessing' stamp: 'srh 1/4/2009 18:57'!
children
	^Array with: cartView! !

!WSCartViewPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 13:53'!
enabled
	^true! !

!WSCartViewPage methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:55'!
model: anObject
	super model: anObject.
	cartView := WSCartView cart: model! !

!WSCartViewPage methodsFor: 'rendering' stamp: 'srh 1/1/2009 13:22'!
renderContentOn: html
	html render: cartView! !

!WSCartViewPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 13:19'!
title
	^'Review Order'! !

!WSCartViewPage methodsFor: 'testing' stamp: 'srh 6/28/2009 22:25'!
valid
	^cartView cart isEmpty not! !

WSWizardPage subclass: #WSConfirmOrderPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSConfirmOrderPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:40'!
enabled
	^model address notNil! !

!WSConfirmOrderPage methodsFor: 'accessing' stamp: 'StuartHerring 9/10/2009 11:46'!
order
	^self session cart! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 11:26'!
renderAddress: anAddress on: html
	html
		definitionTerm: 'Address';
		definitionData: [
			html text: anAddress address1.
			anAddress address2 ifNotNil: [
				html break; text: anAddress address2.
			].
			html
				text: anAddress locality, ' ', anAddress state, ' ', anAddress postcode; break;
				text: anAddress country name]! !

!WSConfirmOrderPage methodsFor: 'rendering' stamp: 'srh 1/1/2009 21:40'!
renderContentOn: html
	html div id: 'confirm-order'; with: [
		html div: [self renderOrderSummaryOn: html].			
		html div: [self renderCustomerDetailsOn: html].			
		html div: [self renderShippingOn: html].
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:07'!
renderCustomerDetailsOn: html
	html heading level: 2; with: 'Customer Details'.
	html definitionList: [
		html 
			definitionTerm: 'Name';
			definitionData: model customer name;
			definitionTerm: 'Email';
			definitionData: model customer email.
	]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/25/2009 10:35'!
renderOrderSummaryOn: html 
	html heading
		level: 2;
		with: 'Order'.
	html table class: #order; with: [
		self order do: [ :o |
			html tableRow: [
				html tableHeading: o name.
				html tableData: o totalInDollars]].
		html tableRow class: #subTotal; with: [
			html tableHeading:  'Subtotal'.
			html tableData: self order totalInDollars].
		html tableRow: [
			html tableHeading: 'Shipping'.
			html tableData: self order shippingInDollars].
		html tableRow class: #total; with: [
			html tableHeading: 'Total'.
			html tableData: self order grandTotalInDollars]]! !

!WSConfirmOrderPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/30/2009 14:06'!
renderShippingOn: html
	html heading level: 2; with: 'Shipping To:'.
	html definitionList: [
		model address name ifNotEmpty: [ html 
			definitionTerm: 'Attn';
			definitionData: model address name
		].
		self renderAddress: model address on: html
	]! !

!WSConfirmOrderPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 13:19'!
title
	^'Confirm Purchase'! !

!WSConfirmOrderPage methodsFor: 'testing' stamp: 'srh 1/1/2009 16:03'!
valid
	^true! !

WSWizardPage subclass: #WSCustomerPage
	instanceVariableNames: 'tempCustomer email2 fields tempAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCustomerPage methodsFor: 'accessing' stamp: 'srh 2/22/2009 12:02'!
children
	^Array with:fields! !

!WSCustomerPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:26'!
enabled
	^true! !

!WSCustomerPage methodsFor: 'initialization' stamp: 'StuartHerring 9/9/2009 14:13'!
initialize
	super initialize.
	tempCustomer := WSCustomer new.
	tempAddress := WSAddress new.
	fields := WSForm new.
	self setupFields.! !

!WSCustomerPage methodsFor: 'rendering' stamp: 'srh 1/1/2009 18:29'!
renderContentOn: html
	html div class: 'customer-details'; with: fields.	! !

!WSCustomerPage methodsFor: 'actions' stamp: 'StuartHerring 11/19/2009 00:55'!
save
	^fields save 
		ifTrue: [
			model customer: tempCustomer.
			model address: tempAddress.
			true]
		ifFalse: [false]! !

!WSCustomerPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/18/2009 22:42'!
setupFields
	| cust shipping |
	cust := WSFieldGroup new
		label: 'Contact Details';
		yourself.
	shipping := WSFieldGroup new
		label: 'Shipping Details';
		yourself.
	fields add: cust.
	fields add: shipping.
	cust add: (WSField text
			label: 'Name';
			on: #name
				of: tempCustomer;
			beRequired;
			yourself).
	cust add: (WSField text
			label: 'Email';
			on: #email
				of: tempCustomer;
			beRequired;
			yourself).
	shipping add: (WSField text
			label: 'Attention';
			on: #name
				of: tempAddress;
			yourself).
	shipping add: (WSField text
			label: 'Address Line 1';
			on: #address1
				of: tempAddress;
			beRequired;
			yourself).
	shipping add: (WSField text
			label: 'Address Line 2';
			on: #address2
				of: tempAddress;
			yourself).
	shipping add: (WSField text
			label: 'Suburb / Town';
			on: #locality
				of: tempAddress;
			beRequired;
			yourself).
	shipping add: (WSField text
			label: 'State / Province';
			on: #state
				of: tempAddress;
			yourself).
	shipping add: (WSField text
			label: 'Postcode';
			on: #postcode
				of: tempAddress;
			yourself).
	shipping add: ((WSDropDownField list:	(WSCountry countryList sort: [ :a :b | a name < b name ]))
			default: 'AU';
			label: 'Country';
			on: #country
				of: tempAddress;
			beRequired;
			yourself)! !

!WSCustomerPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:31'!
title
	^'Customer Details'! !

!WSCustomerPage methodsFor: 'testing' stamp: 'srh 1/1/2009 20:59'!
valid
	^fields valid! !

!WSWizardPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:38'!
enabled
	^false! !

!WSWizardPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:38'!
model: anObject
	model := anObject! !

!WSWizardPage methodsFor: 'as yet unclassified' stamp: 'srh 1/1/2009 18:58'!
onEnter! !

!WSWizardPage methodsFor: 'actions' stamp: 'srh 1/1/2009 14:32'!
save
	"Attempt to save the data on the page, return success or failure"
	^true! !

!WSWizardPage methodsFor: 'accessing' stamp: 'srh 1/1/2009 12:54'!
title
	^self subclassResponsibility.! !

!WSWizardPage methodsFor: 'testing' stamp: 'srh 1/1/2009 15:55'!
valid
	^false! !

WASession subclass: #WSSession
	instanceVariableNames: 'store magmaSession pool services mailer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSSession methodsFor: 'accessing' stamp: 'srh 3/23/2009 17:46'!
actionUrlForKey: aString 
    | url |
    url := super actionUrlForKey: aString.
    (self currentRequest cookieAt: self application handlerCookieName) 
            ifNotNil: [ url parameters removeKey: self application handlerField ].
    ^ url! !

!WSSession methodsFor: 'updating' stamp: 'StuartHerring 9/5/2009 23:46'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!WSSession methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 12:41'!
announcer
	^services announcer! !

!WSSession methodsFor: 'actions' stamp: 'srh 4/20/2009 21:40'!
expire
	self returnMagmaSession! !

!WSSession methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 00:06'!
initialize
	super initialize.
	services := WSStoreServices new
		transactionProviderBlock: [ self magmaSession ];
		storeBlock: [self store];
		yourself.
		! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:38'!
keepTransaction
	^true! !

!WSSession methodsFor: 'accessing' stamp: 'StuartHerring 11/9/2010 20:38'!
magmaSession
	^magmaSession ifNil: [magmaSession := self pool takeSession ]! !

!WSSession methodsFor: 'exceptions' stamp: 'StuartHerring 9/5/2009 14:33'!
on: anAnnouncement do: aBlock
	self announcer on: anAnnouncement do: aBlock.! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:00'!
pool
	^pool ifNil: [ pool := (WSConnectionPool at: (self application preferenceAt: #poolId))].! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:40'!
refreshMagmaSession
	magmaSession ifNotNil: [ magmaSession refresh ].! !

!WSSession methodsFor: 'request handling' stamp: 'StuartHerring 9/5/2009 12:25'!
responseForRequest: aRequest
" If return the transaction after each request, unless we've decided we need to keep it. "
	self refreshMagmaSession.
	^[services useDuring: [super responseForRequest: aRequest]]
		ensure: [ self keepTransaction ifFalse: [ self returnMagmaSession ]]! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/20/2009 21:48'!
returnMagmaSession
	magmaSession ifNotNil: [ self pool returnSession: magmaSession. magmaSession := nil ]! !

!WSSession methodsFor: 'responding' stamp: 'srh 4/20/2009 20:47'!
returnResponse: aResponse 
    (self currentRequest cookieAt: self application handlerCookieName) 
        ifNil: [ aResponse addCookie: self sessionCookie ].
    ^ super returnResponse: aResponse
! !

!WSSession methodsFor: 'actions' stamp: 'StuartHerring 11/16/2009 23:04'!
store
	store ifNil: [
		store := self magmaSession root at: #store ifAbsent: [ self magmaSession commit: [ self magmaSession root at: #store put: WSStore new]].
		mailer := WSMailer store: store.
		mailer listenTo: self announcer].
	^store! !

!WSSession methodsFor: 'as yet unclassified' stamp: 'srh 4/11/2009 12:43'!
urlForProduct: aProduct
	^self baseUrl
		addParameter: #product value: aProduct id;
		yourself.! !

!UndefinedObject methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/6/2009 22:58'!
expressionValue: aCollection
	^''! !

WASystemConfiguration subclass: #WSConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSConfiguration methodsFor: 'attributes' stamp: 'srh 7/13/2009 17:48'!
attributes
	^Array 
		with: (WAStringAttribute key: #paypalHost group: #paypal)
		with: (WAStringAttribute key: #paypalIPNHost group: #paypal)
		with: (WAStringAttribute key: #accountEmail group: #paypal)
		with: (WAStringAttribute key: #poolId group: #connectionPool)! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:49'!
paypalHost
	^ 'www.sandbox.paypal.com'! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 7/13/2009 17:49'!
paypalIPNHost
	^ 'ppdummy.stuartherring.net'! !

!WSConfiguration methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:17'!
poolId
	^'storePool'! !

!BlockClosure methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/5/2009 22:30'!
expressionValue
	^numArgs > 0 
		ifTrue: [ '' ] " Can't handle block with args, so just return empty string "
		ifFalse: [self value expressionValue]! !

WAImageTag subclass: #WSImageBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSImageBrush methodsFor: 'accessing' stamp: 'srh 4/14/2009 11:58'!
image: anImage
	self url: WSImageLibrary / anImage.! !

WAFileLibrary subclass: #WSAdminLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Admin'!

!WSAdminLibrary methodsFor: 'accessing' stamp: 'srh 5/18/2009 17:50'!
selectorsToInclude
	^#(styleCss)! !

!WSAdminLibrary methodsFor: 'uploaded' stamp: 'StuartHerring 11/18/2009 21:01'!
styleCss
	^'#home fieldSet {
float: left;
width: 45%;
}
textarea {
width: 40em;
height: 10em;
}
#home h2  a {
text-decoration: none;
display: block;
color: black;
font-family: sans;
text-align: center;
height: 100%;
}
#home h2 {
border: outset 1px red;
width: 10em;
float: left;
margin-left: 1em;
font-size: 1.2em;
background-color: #ffcccc;
}

#home h2:hover {
border-style: inset;
}


.actions {
margin-bottom: 0.5em;
border: solid black 1px;
background-color: #cccccc;
}

.actions a {
color: blue;
text-decoration: none;
padding-left: 0.3em;
padding-right: 0.3em;
}
.actions a:hover {
background-color: #dddddd;
color: red;
}

table {
border-collapse: collapse
}

th {
background-color: #cccccc;
border: 1px solid #444444;
}

td {
border: 1px solid #444444;
vertical-align: top;
padding-top: 2px;
padding-bottom: 2px;
padding-left: 5px;
padding-right: 5px;
}

td.hl {
background-color: #eeeeee;
}'! !

WAFileLibrary subclass: #WSImageLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSImageLibrary commentStamp: '<historical>' prior: 0!
This class adds the ability to serve content from files external to the image.

The files go in to a subdirectory from the running directory called 'files'
The URL to access the files is: http://localhost:7777/seaside/files/external/myfile.png

Seaside protects against malicious users attempting to use '..' to access above the 'files' directory.!

!WSImageLibrary class methodsFor: 'testing' stamp: 'srh 12/31/2008 08:05'!
handlesFolder: aSymbol 
	^ aSymbol = #external! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 12/31/2008 08:31'!
documentAt: aFilename ifAbsent: aBlock 
	| fn files mimeType fileStream |
	files := FileDirectory default directoryNamed: 'files'.
	files exists
		ifFalse: [^ aBlock value].
	fn := files fullNameFor: aFilename.
	^ (files fileOrDirectoryExists: fn)
		ifTrue: [mimeType := self mimetypeForFile: aFilename.
			fileStream := (files readOnlyFileNamed: fn) binary.
			(WAStreamResponse on: fileStream)
				contentType: (mimeType
						ifNil: ['application/octet-stream']);
				 headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
				 yourself]
		ifFalse: [aBlock value]! !

!WSImageLibrary methodsFor: 'accessing' stamp: 'srh 4/14/2009 11:53'!
urlOf: aSymbol using: aHandler 
	^ aHandler baseUrl addToPath: 'external';
		
		addToPath: (self asFilename: aSymbol);
		 yourself! !

Announcement subclass: #WSAddToCart
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSAddToCart class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 21:16'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself! !

!WSAddToCart methodsFor: 'initialization' stamp: 'srh 3/10/2009 21:24'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.! !

!WSAddToCart methodsFor: 'accessing' stamp: 'srh 3/10/2009 21:24'!
product
	^product! !

Announcement subclass: #WSEmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

Announcement subclass: #WSLightbox
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSLightbox class methodsFor: 'as yet unclassified' stamp: 'srh 3/10/2009 20:59'!
component: aComponent
	^self basicNew
		initializeWithComponent: aComponent;
		yourself! !

!WSLightbox methodsFor: 'accessing' stamp: 'srh 3/10/2009 20:37'!
component
	^component! !

!WSLightbox methodsFor: 'initialization' stamp: 'srh 3/10/2009 20:37'!
initializeWithComponent: aComponent 
	component := aComponent.
	self initialize! !

Announcement subclass: #WSOpenDialogue
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSOpenDialogue class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/18/2009 19:16'!
component: aComponent
	^self basicNew
		initializeWithComponent: aComponent;
		yourself.! !

!WSOpenDialogue methodsFor: 'accessing' stamp: 'StuartHerring 11/18/2009 19:16'!
component
	^component! !

!WSOpenDialogue methodsFor: 'initialization' stamp: 'StuartHerring 11/18/2009 19:16'!
initializeWithComponent: aComponent
	self initialize.
	component := aComponent.! !

Announcement subclass: #WSReviewCart
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSReviewCart class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/16/2009 23:10'!
cart: aCart
	^self basicNew
		initializeWithCart: aCart;
		yourself! !

!WSReviewCart methodsFor: 'accessing' stamp: 'StuartHerring 11/16/2009 23:11'!
cart
	^cart! !

!WSReviewCart methodsFor: 'initialization' stamp: 'StuartHerring 11/16/2009 23:11'!
initializeWithCart: aCart
	self initialize.
	cart := aCart! !

Announcement subclass: #WSStatusChanged
	instanceVariableNames: 'order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Announcements'!

!WSStatusChanged class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:14'!
order: anOrder
	^self basicNew 
		initializeWithOrder: anOrder;
		yourself! !

!WSStatusChanged methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 23:13'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.! !

!WSStatusChanged methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 14:38'!
order
	^order! !

!WSStatusChanged methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 21:32'!
status
	^order status! !

Notification subclass: #WSDynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSDynamicVariable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 07:09'!
use: factoryBlock during: aBlock
	" The factoryBlock should return a new instance of the value to be made available" 
	^ aBlock on: self do: [ :notification | notification resume: factoryBlock value ]! !

!WSDynamicVariable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 07:09'!
value
	^self raiseSignal! !

WSDynamicVariable subclass: #WSStoreServices
	instanceVariableNames: 'announcer transactionProviderBlock storeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStoreServices commentStamp: '<historical>' prior: 0!
I provide access to global store services, such as:
	* Transaction provider (#commit:, #abort:)
	* Announcer (#on:do:, #announce)
	
!

!WSStoreServices class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:59'!
announcer 
	| v |
	v := self value.
	^v ifNotNil: [v announcer ]! !

!WSStoreServices class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/15/2009 00:22'!
commit: aBlock
	"Convenience Method for committing a transaction"
	^self transactionProvider commit: aBlock! !

!WSStoreServices class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:22'!
configuration
	^self value store settings! !

!WSStoreServices class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2009 13:39'!
repository
	"Returns an object implementing the Dictionary protocol, to use for storing additional configuration"
	^self transactionProvider root! !

!WSStoreServices class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 12:23'!
transactionProvider 
	^self value transactionProvider! !

!WSStoreServices methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 12:03'!
announcer 
	^announcer.! !

!WSStoreServices methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 00:06'!
initialize 
	super initialize.
	announcer := Announcer new.! !

!WSStoreServices methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 23:12'!
store
	^storeBlock value! !

!WSStoreServices methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 23:12'!
storeBlock: aBlock
	storeBlock := aBlock.! !

!WSStoreServices methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 12:28'!
transactionProvider
	^ transactionProviderBlock value! !

!WSStoreServices methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 12:28'!
transactionProviderBlock: anObject 
	transactionProviderBlock := anObject! !

!WSStoreServices methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 14:34'!
useDuring: aBlock.
	^self class use: self during: aBlock! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 21:58'!
wsImage
	^self brush: WSImageBrush new! !

!WARenderCanvas methodsFor: '*webstore-components' stamp: 'srh 3/10/2009 22:01'!
wsImage: anImage
	^(self brush: WSImageBrush new) 
		image:anImage;
		yourself! !

WATask subclass: #WSCheckoutProcess
	instanceVariableNames: 'wizard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Checkout'!

!WSCheckoutProcess methodsFor: 'processing' stamp: 'StuartHerring 11/18/2009 22:31'!
go
	[| order | 
	self isolate: [
		order := self call: wizard.
		order ifNil: [self answer].
	].
	[(WSPlaceOrderCommand store: self store order: order) run ] 
		on: WSOrderError do: [:e | 
			self call: (WSOrderErrorPage error: e).
			wizard goToFirstPage].
	self call: (WSPayPalCheckout order: order).
	self session announce: WSEmptyCart new.
	self answer] repeat! !

!WSCheckoutProcess methodsFor: 'initialization' stamp: 'srh 1/1/2009 22:00'!
initialize
	super initialize.
	wizard := WSCheckoutWizard new.! !

!WSCheckoutProcess methodsFor: 'actions' stamp: 'srh 1/2/2009 17:50'!
store
	^self session store! !

!WSCheckoutProcess methodsFor: 'accessing' stamp: 'srh 1/4/2009 21:00'!
wizard
	"for testing purposes"
	^wizard! !

!WSCheckoutProcess methodsFor: 'accessing' stamp: 'srh 1/4/2009 21:00'!
wizard: aWizard
	"for testing purposes"
	wizard := aWizard! !

WATask subclass: #WSProductCustomizer
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Components'!

!WSProductCustomizer class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/11/2009 18:25'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSProductCustomizer methodsFor: 'processing' stamp: 'StuartHerring 9/11/2009 18:43'!
go
	self call: (WSAddOrderItem product: product orderCopy)! !

!WSProductCustomizer methodsFor: 'initialization' stamp: 'StuartHerring 9/11/2009 18:43'!
initializeWithProduct: aProduct
	self initialize.
	product := aProduct! !

!Dictionary methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/5/2009 21:12'!
expressionChild: aSymbol
	^self at: aSymbol ifAbsent: [ nil ]! !

!Object methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/5/2009 20:33'!
expressionChild: aSymbol
	^[self perform: aSymbol] 
		on: Error do: [ nil ]! !

!Object methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/5/2009 20:24'!
expressionValue
	^self displayString! !

!Object methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/5/2009 20:32'!
expressionValue: aCollection
 	^aCollection isEmpty 
		ifTrue: [ self expressionValue ]
		ifFalse:[ (self expressionChild: aCollection first) 
				expressionValue: aCollection allButFirst ]! !

Object subclass: #WSAnalytics
	instanceVariableNames: 'key attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Analytics'!

!WSAnalytics class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2010 00:26'!
key: aKey
	^self basicNew
		initializeWithKey: aKey;
		yourself! !

!WSAnalytics methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/7/2010 15:35'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<script type="text/javascript">/*<!![CDATA[*/';
		nextPutAll: self script;
		nextPutAll: '/*]]>*/</script>'! !

!WSAnalytics methodsFor: 'initialization' stamp: 'StuartHerring 3/24/2010 00:39'!
initializeWithKey: aKey
	key := aKey.
	attributes := Dictionary new.
	attributes at: 'type' put: 'text/javascript'! !

!WSAnalytics methodsFor: 'accessing' stamp: 'StuartHerring 3/24/2010 00:25'!
script
	^'
  var _gaq = _gaq || [];
  _gaq.push([''_setAccount'', ''UA-', (key ifNil: ['XXXX']), ''']);
  _gaq.push([''_trackPageview'']);

  (function() {
    var ga = document.createElement(''script''); ga.type = ''text/javascript''; ga.async = true;
    ga.src = (''https:'' == document.location.protocol ? ''https://ssl'' : ''http://www'') + ''.google-analytics.com/ga.js'';
    var s = document.getElementsByTagName(''script'')[0]; s.parentNode.insertBefore(ga, s);
  })();
'! !

!WSAnalytics methodsFor: 'accessing' stamp: 'StuartHerring 3/24/2010 00:30'!
tag
	^'script'! !

Object subclass: #WSCommand
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCommand commentStamp: 'srh 6/28/2009 21:50' prior: 0!
A WSCommand is a base class for implementing Commands.
A command is a single unit of work within the system, and operates within a transaction.
If a command throws an exception, the transaction will be rolled back.

Instance Variables
	transactionProvider:		<Object>

transactionProvider
	- An object that implements #commit: and #abort.  The default implementation pulls it from the Seaside session, and assumes it's available as #magmaSession
!

WSCommand subclass: #WSAddProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSAddProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:41'!
do
	store addProduct: product.! !

!WSAddProductCommand methodsFor: 'initialization' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSAddtoCollectionCommand
	instanceVariableNames: 'collection object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSAddtoCollectionCommand commentStamp: 'StuartHerring 9/14/2009 12:21' prior: 0!
generic command for adding an item to a collection!

!WSAddtoCollectionCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/14/2009 12:22'!
add: anObject to: aCollection
	^self basicNew
		initializeWithCollection: aCollection object: anObject;
		yourself! !

!WSAddtoCollectionCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/14/2009 12:23'!
do
	collection add: object! !

!WSAddtoCollectionCommand methodsFor: 'initialization' stamp: 'StuartHerring 9/14/2009 12:29'!
initializeWithCollection: aCollection  object: anObject
	self initialize.
	collection := aCollection.
	object := anObject.! !

WSCommand subclass: #WSApplyFormCommand
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSApplyFormCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 14:20'!
form: aForm
	^self basicNew
		initializeWithForm: aForm;
		yourself! !

!WSApplyFormCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 01:03'!
do
	^form save.! !

!WSApplyFormCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 14:20'!
initializeWithForm: aForm
	form := aForm.
	self initialize.! !

WSCommand subclass: #WSCancelOrderCommand
	instanceVariableNames: 'order reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSCancelOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 20:56'!
order: anOrder reason: aReason
	^self basicNew
		initializeWithOrder: anOrder reason: aReason;
		yourself! !

!WSCancelOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 18:51'!
do
	order cancel: reason.! !

!WSCancelOrderCommand methodsFor: 'initialization' stamp: 'srh 2/28/2009 20:56'!
initializeWithOrder: anOrder reason: aReason.
	self initialize.
	order := anOrder.
	reason := aReason.! !

!WSCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:15'!
new
	self shouldNotImplement! !

!WSCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/25/2009 22:05'!
do
	"Override this to actually do something"! !

!WSCommand methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 12:22'!
initialize
	transactionProvider := WSStoreServices transactionProvider.! !

!WSCommand methodsFor: 'processing' stamp: 'StuartHerring 11/19/2009 01:03'!
run
	^[transactionProvider
		commit: [self do]]
		on: Error
		do: [:e | 
			transactionProvider abort.
			e signal]! !

WSCommand subclass: #WSConfirmPaymentCommand
	instanceVariableNames: 'order reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSConfirmPaymentCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:11'!
order: anOrder reference: aReference 
	^self basicNew
		initializeWithOrder: anOrder reference: aReference ;
		yourself! !

!WSConfirmPaymentCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:11'!
do
	order confirmPayment: reference ! !

!WSConfirmPaymentCommand methodsFor: 'initialization' stamp: 'StuartHerring 9/1/2009 22:09'!
initializeWithOrder: anOrder reference: aReference
	self initialize.
	order := anOrder.
	reference := aReference! !

WSCommand subclass: #WSDeleteProductCommand
	instanceVariableNames: 'store product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDeleteProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:40'!
store: aStore product: aProduct 
	^self basicNew
		initializeWithStore: aStore product: aProduct;
		yourself.! !

!WSDeleteProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:42'!
do
	store deleteProduct: product! !

!WSDeleteProductCommand methodsFor: 'initialization' stamp: 'srh 2/28/2009 21:41'!
initializeWithStore: aStore product: aProduct
	store := aStore.
	product := aProduct.
	self initialize.! !

WSCommand subclass: #WSPlaceOrderCommand
	instanceVariableNames: 'store order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSPlaceOrderCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 21:22'!
store: aStore order: anOrder
	^self basicNew
		initializeWithStore: aStore order: anOrder;
		yourself! !

!WSPlaceOrderCommand methodsFor: 'as yet unclassified' stamp: 'srh 6/13/2009 18:50'!
do
	store placeOrder: order.! !

!WSPlaceOrderCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 21:23'!
initializeWithStore: aStore order: anOrder
	store := aStore.
	order := anOrder.
	self initialize.
! !

WSCommand subclass: #WSProductCommand
	instanceVariableNames: 'product'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

WSProductCommand subclass: #WSDisableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSDisableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSDisableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product disable! !

WSProductCommand subclass: #WSEnableProductCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSEnableProductCommand class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:39'!
product: aProduct
	^self basicNew
		initializeWithProduct: aProduct;
		yourself.! !

!WSEnableProductCommand methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 21:38'!
do
	product enable! !

!WSProductCommand methodsFor: 'initialization' stamp: 'srh 1/25/2009 22:16'!
initializeWithProduct: aProduct
	product := aProduct.
	self initialize.
! !

WSProductCommand subclass: #WSSetPreviewCommand
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSSetPreviewCommand class methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:36'!
product: aProduct image: anImage
	^self basicNew
		initializeWithProduct: aProduct image: anImage;
		yourself! !

!WSSetPreviewCommand methodsFor: 'as yet unclassified' stamp: 'srh 1/26/2009 13:37'!
do
	product preview: image! !

!WSSetPreviewCommand methodsFor: 'initialization' stamp: 'srh 1/26/2009 13:36'!
initializeWithProduct: aProduct image: anImage
	image := anImage.
	self initializeWithProduct: aProduct.
	! !

WSCommand subclass: #WSRemoveFromCollectionCommand
	instanceVariableNames: 'collection object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSRemoveFromCollectionCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/14/2009 12:36'!
remove: anObject from: aCollection
	^self basicNew
		initializeWithCollection: aCollection object: anObject;
		yourself! !

!WSRemoveFromCollectionCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/14/2009 12:37'!
do
	collection remove: object! !

!WSRemoveFromCollectionCommand methodsFor: 'initialization' stamp: 'StuartHerring 9/14/2009 12:36'!
initializeWithCollection: aCollection  object: anObject
	self initialize.
	collection := aCollection.
	object := anObject.! !

WSCommand subclass: #WSShipOrderCommand
	instanceVariableNames: 'order reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Commands'!

!WSShipOrderCommand class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 23:04'!
order: anOrder reference: aReference 
	^self basicNew
		initializeWithOrder: anOrder reference: aReference;
		yourself! !

!WSShipOrderCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:43'!
do
	order ship: reference! !

!WSShipOrderCommand methodsFor: 'initialization' stamp: 'StuartHerring 9/1/2009 22:43'!
initializeWithOrder: anOrder reference: aReference 
	self initialize.
	order := anOrder.
	reference := aReference! !

Object subclass: #WSConnectionPool
	instanceVariableNames: 'location minFree maximum sessions enabled activeSessions activeSema highWater backgroundStrategy'
	classVariableNames: 'Pools'
	poolDictionaries: ''
	category: 'WebStore-MagmaPools'!

!WSConnectionPool commentStamp: 'srh 6/28/2009 21:50' prior: 0!
A WSConnectionPool is a Connection pool for MagmaSessions.

Instance Variables
	activeSema:		<Semaphore> 
	activeSessions:		<IdentitySet> 
	enabled:		<Boolean> 
	highWater:		<Integer> 
	location:		<MagmaLocation> 
	maximum:		<Object>
	minFree:		<Object>
	sessions:		<Object>

activeSema
	- protects access to the activeSessions set

activeSessions
	- a set containing the active sessions

enabled
	- whether or not this pool is enabled

highWater
	- the number of free sessions above which returned sessions will be discarded.

location
	- the MagmaLocation from which to obtain new sessions

maximum
	- the hard maximum number of sessions to make available - requests will block until a session is returned when this is hit

minFree
	- the minimum number of sessions to keep on hand.

sessions
	- the available sessions
!

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 23:34'!
at: aSymbol
	^Pools at: aSymbol! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/12/2012 20:13'!
initialize
	Pools := Dictionary new.! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 21:14'!
newWithLocation: aLocation
	^self basicNew
		initializeWithLocation: aLocation;
		yourself.! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/12/2012 20:22'!
register: aLocation withName: aSymbol
	Pools at: aSymbol ifPresent: [ :pool | pool shutDown].
	^(Pools at: aSymbol put: (self newWithLocation: aLocation))! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
remove: aSymbol
	Pools at: aSymbol ifPresent: [ :p |
		p shutDown.
		Pools remove: aSymbol ].! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
shutDown
	"close the connection pools"
	Pools do: [ :p | p shutDown ].! !

!WSConnectionPool class methodsFor: 'as yet unclassified' stamp: 'srh 4/19/2009 22:46'!
startUp
	"bring up the connection pools"
	Pools do: [ :p | p startUp ]! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2010 22:13'!
active
	^activeSessions size! !

!WSConnectionPool methodsFor: 'private' stamp: 'StuartHerring 9/12/2010 05:28'!
allocateSessions: number 
	1 to: number
		do: 
			[ :i | 
			sessions nextPut: (location newSession
					connectAs: 'pool';
					yourself) ].! !

!WSConnectionPool methodsFor: 'private' stamp: 'StuartHerring 9/11/2010 22:52'!
assureMinimumAvailable
	" Ensures that there's at least minFree sessions available - but no more than maximum "
	| newSessions |
	newSessions := (minFree - self available) min: (maximum - self sessions).

	self runInBackground: [ self allocateSessions: newSessions ].! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2010 08:41'!
available
	^sessions size! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2010 22:55'!
backgroundStrategy: aBlock
	"Sets strategy for running in the background. Pretty much only used to simplify testing.
	aBlock should be a block taking another block as an argument 
		- the code to run in the 'background'"
	backgroundStrategy := aBlock.! !

!WSConnectionPool methodsFor: 'testing' stamp: 'StuartHerring 9/11/2010 21:42'!
enabled
	^enabled! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2010 09:06'!
highWaterLevel
	^highWater! !

!WSConnectionPool methodsFor: 'initialization' stamp: 'StuartHerring 9/11/2010 22:52'!
initializeWithLocation: aLocation.
	self initialize.
	location := aLocation.
	minFree := 3.
	highWater := 7.
	maximum := 15.
	enabled := false.
	sessions := SharedQueue new.
	activeSessions := IdentitySet new.
	activeSema := Semaphore forMutualExclusion.
	self backgroundStrategy: [ :aBlock | aBlock forkAt: Processor userBackgroundPriority]! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2010 23:18'!
maximum
	^maximum! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2010 22:09'!
minimumAvailable
	^minFree! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/12/2010 09:16'!
returnSession: aSession 
	" Returns a session to the pool.
	  Abort the session to make sure there's nothing uncommitted, then remove it from the active list.
	  Then we add it back into the available sessions if we're not over the high water mark "
	aSession abort.
	activeSema critical: 
		[ activeSessions 
			remove: aSession
			ifAbsent: [  ].
		sessions size >= highWater 
			ifFalse: [ sessions nextPut: aSession ]
			ifTrue: [ aSession disconnect ] ].! !

!WSConnectionPool methodsFor: 'private' stamp: 'StuartHerring 9/11/2010 22:55'!
runInBackground: aBlock
	backgroundStrategy value: aBlock
	! !

!WSConnectionPool methodsFor: 'accessing' stamp: 'StuartHerring 9/12/2010 08:42'!
sessions
	"I return the total number of sessions - both active and available"
	^self active + self available ! !

!WSConnectionPool methodsFor: 'initialization' stamp: 'StuartHerring 9/12/2010 12:40'!
shutDown
	| lastSession |
	enabled := false.
	"close all active sessions, then flush the pool".
	activeSema critical: [ activeSessions removeAllSuchThat: [ :s | s disconnect. true ]].
	sessions flushAllSuchThat: [ :s | lastSession := s. s disconnect. true ].
	location isLocal ifTrue: [ lastSession ifNotNil: [ lastSession closeRepository ] ]! !

!WSConnectionPool methodsFor: 'running' stamp: 'StuartHerring 9/12/2010 05:30'!
startUp
	self assureMinimumAvailable.
	enabled := true.! !

!WSConnectionPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/11/2010 23:06'!
takeSession
	^ enabled 
		ifTrue: 
			[ activeSema critical: 
				[ | session| session := activeSessions add: sessions next.
				self assureMinimumAvailable.
				session] ]
		ifFalse: [ nil ]! !

Object subclass: #WSEventTracker
	instanceVariableNames: 'category event label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Analytics'!

!WSEventTracker class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:35'!
category: aCategory event: anEvent
	^self category: aCategory  event: anEvent label: nil value: nil! !

!WSEventTracker class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:36'!
category: aCategory event: anEvent label: aLabel
	^self category: aCategory  event: anEvent label: aLabel value: nil! !

!WSEventTracker class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 22:30'!
category: aCategory event: anEvent label: aLabel value: aValue
	^self basicNew
		initializeWithCategory: aCategory  event: anEvent label: aLabel value: aValue;
		yourself! !

!WSEventTracker class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:36'!
category: aCategory event: anEvent value: aValue
	^self category: aCategory  event: anEvent label: nil value: aValue! !

!WSEventTracker class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/21/2010 12:57'!
new
	self shouldNotImplement! !

!WSEventTracker methodsFor: 'initialization' stamp: 'StuartHerring 3/22/2010 19:39'!
initializeWithCategory: aCategory event: anEvent label: aLabel value: aValue 
	self initialize.
	category := aCategory.
	event := anEvent.
	label := aLabel.
	value :=	 aValue
! !

!WSEventTracker methodsFor: 'printing' stamp: 'StuartHerring 3/24/2010 23:19'!
printString
	^'_gaq.push([''_trackEvent'', ''{1}'', ''{2}'', ''{3}''{4}]);' format: { 
		category copyReplaceAll: '''' with: '\'''.
		event copyReplaceAll: '''' with: '\'''.
		label isNil ifTrue: [ '' ] ifFalse: [ label copyReplaceAll: '''' with: '\'''].
		value isNil ifTrue: [ '' ] ifFalse: [ ', ', value asNumber printString]}.! !

WSEventTracker subclass: #WSOrderEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Analytics'!

!WSOrderEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:49'!
category: aCategory event: anEvent label: aLabel value: aValue
	self shouldNotImplement! !

!WSOrderEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:51'!
checkoutOrder: anOrder
	^self basicNew
		initializeWithCategory: 'Order' event: 'Checkout' label: nil value: anOrder total! !

!WSOrderEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:51'!
payForOrder: anOrder
	^self basicNew
		initializeWithCategory: 'Order' event: 'Pay' label: nil value: anOrder total! !

!WSOrderEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:50'!
reviewOrder: anOrder
	^self basicNew
		initializeWithCategory: 'Order' event: 'Review' label: nil value: anOrder total! !

WSEventTracker subclass: #WSProductEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Analytics'!

!WSProductEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/30/2010 11:42'!
addProduct: aProduct
	^self basicNew
		initializeWithCategory: 'Product' event: 'Add' label: (self productLabelFor: aProduct ) value: nil
		yourself! !

!WSProductEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/22/2010 20:40'!
category: aCategory event: anEvent label: aLabel value: aValue
	self shouldNotImplement! !

!WSProductEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/30/2010 11:42'!
chooseThumbnailForProduct: aProduct
	^self basicNew
		initializeWithCategory: 'Product' event: 'Choose Thumbnail' label: (self productLabelFor: aProduct) value: nil
		yourself! !

!WSProductEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/30/2010 11:41'!
customizeProduct: aProduct
	^self basicNew
		initializeWithCategory: 'Product' event: 'Customize' label: (self productLabelFor: aProduct) value: nil
		yourself! !

!WSProductEvent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/30/2010 11:41'!
productLabelFor: aProduct
	^'Product {1}: {2}' format: { aProduct id. aProduct name}! !

Object subclass: #WSExpressionEngine
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Expression'!

!WSExpressionEngine commentStamp: 'StuartHerring 9/5/2009 20:27' prior: 0!
I am a text replacement engine with a simple expression language.

* Expressions are marked with %, and terminated by whitespace or ;
* Expressions evaluate to entries in the ExpressionEngine's internal dictionary, with dot notation used to navigate the graph.
* Blocks are parsed 
!

!WSExpressionEngine methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 19:55'!
at: key put: value
	graph at: key put: value! !

!WSExpressionEngine methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 19:56'!
initialize
	super initialize.
	graph := Dictionary new.! !

!WSExpressionEngine methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 20:04'!
process: text
	^(self processStream: text readStream into: ('' writeStream)) contents.! !

!WSExpressionEngine methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2010 22:43'!
processExpressionFrom: readStream into: writeStream
	| char expression node |
	(char := readStream next) = $% ifTrue: [ ^writeStream nextPut: char ].
	node := WriteStream on: (String new).
	expression := OrderedCollection new.
	[ char notNil] whileTrue: [
		(readStream atEnd 
			or: [char = $
			or: [char = $; 
			or: [char isAlphaNumeric not ]]])
				ifTrue: [ 
					(readStream atEnd and: [(char = $;) not ]) ifTrue: [ node nextPut: char ].
					expression add: node contents asSymbol. node := WriteStream on: (String new).
					char = $. ifFalse: [
						writeStream nextPutAll: (graph expressionValue: expression).
						(char = $; or: [readStream atEnd]) ifFalse: [ writeStream nextPut: char ].
						^writeStream]]
				ifFalse: [node nextPut: char].
		char := readStream next]
	
! !

!WSExpressionEngine methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 21:24'!
processStream: readStream into: writeStream
	| chunk |
	[ chunk := readStream upTo: $%.
	  readStream atEnd ] whileFalse: [
		writeStream nextPutAll: chunk.
		self processExpressionFrom: readStream into: writeStream].
	writeStream nextPutAll: chunk.
	^writeStream.
! !

Object subclass: #WSListener
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSListener methodsFor: 'enumerating' stamp: 'srh 3/21/2009 11:17'!
do: anAnnouncement
	"Perform the appropriate action for an announcement"
	self subclassResponsibility! !

!WSListener methodsFor: 'as yet unclassified' stamp: 'srh 3/21/2009 11:17'!
handles
	"Return a collection of Announccement classes this listener handles"
	^self subclassResponsibility! !

Object subclass: #WSMailer
	instanceVariableNames: 'store adminMessages customerMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Messages'!

!WSMailer commentStamp: 'StuartHerring 9/5/2009 09:48' prior: 0!
I am responsible for the delivery of messages.
I create WSMessage objects in rection to notifications and send the via email and log them in the system!

!WSMailer class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/4/2009 13:19'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	"Copied from SeasidePlatformSupport  - mostly so I hav more control over the server"
	self smtpServer = 'dummy' ifFalse: [
		SMTPClient
			deliverMailFrom: fromAddress
			to: recipientList
			text: messageText
			usingServer: self smtpServer]! !

!WSMailer class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:09'!
smtpServer
	^WSStoreServices configuration at: #smtpServer! !

!WSMailer class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 13:42'!
store: aStore 
	^self basicNew
		initializeWithStore: aStore;
		yourself! !

!WSMailer methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 21:32'!
initialize
	super initialize.
	adminMessages := Dictionary new
		at: WSUnconfirmedStatus
		put: [ :o | WSOrderStatusMessage adminNewOrder: o];
		at: WSConfirmedStatus
		put: [ :o | WSOrderStatusMessage adminPaymentConfirmedForOrder: o];
		yourself.
	customerMessages := Dictionary new
		at: WSUnconfirmedStatus 
		put: [ :o | WSOrderStatusMessage customerNewOrder: o ];
		at: WSConfirmedStatus 
		put: [ :o | WSOrderStatusMessage customerPaymentConfirmedForOrder: o ];
		at: WSShippedStatus 
		put: [ :o | WSOrderStatusMessage customerShippedOrder: o ];
		at: WSCancelledStatus
		put: [ :o | WSOrderStatusMessage customerOrderCancelled: o ];
		yourself! !

!WSMailer methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 09:52'!
initializeWithStore: aStore
	self initialize.
	store := aStore.! !

!WSMailer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/16/2009 23:02'!
listenTo: anAnnouncer
	anAnnouncer on: WSStatusChanged do: [ :ann |
		self send: ann status class messageIn: adminMessages for: ann order.
		self send: ann status class messageIn: customerMessages for: ann order]! !

!WSMailer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 21:45'!
send: type messageIn: messageDict for: anOrder
	(messageDict includesKey: type) ifTrue: [
		| msg |
		msg := ((messageDict at: type) value: anOrder).
		anOrder logMessage: msg.
		store logMessage: msg.
		self sendMessage: msg]! !

!WSMailer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 23:09'!
sendMessage: msg
	self class 
		deliverMailFrom: msg sender 
		to: (Array with: msg recipient) 
		text: ('From: {1}\To: {2}\Subject: {3}\{4}' withCRs format: {msg sender. msg recipient. msg subject. msg message}).! !

!WSMailer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 16:52'!
setUpMessageTypes
	adminMessages := Dictionary new.
	customerMessages := Dictionary new.! !

Object subclass: #WSObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

WSObject subclass: #WSAddress
	instanceVariableNames: 'address1 address2 postcode locality state country name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 17:17'!
address1
	^address1! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:02'!
address1: anAddress
	address1 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2
	^address2! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:05'!
address2: anAddress
	address2 := anAddress.! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country
	^country! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
country: aCountry
	country := aCountry! !

!WSAddress methodsFor: 'testing' stamp: 'StuartHerring 9/9/2009 13:48'!
isLocal 
	^country isLocal! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:07'!
locality
	^locality! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
locality: aLocality
	locality := aLocality! !

!WSAddress methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 14:06'!
name
	^name! !

!WSAddress methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 14:05'!
name: aName
	name := aName! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode
	^postcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
postcode: aPostcode
	postcode := aPostcode! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:08'!
state
	^state! !

!WSAddress methodsFor: 'accessing' stamp: 'srh 1/1/2009 18:10'!
state: aState
	state := aState! !

WSAddress subclass: #WSShippingAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippingAddress commentStamp: 'StuartHerring 9/9/2009 14:14' prior: 0!
This class is deprecated.
!

WSObject subclass: #WSCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

WSObject subclass: #WSConfigurationItem
	instanceVariableNames: 'name group value description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSConfigurationItem class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 16:29'!
name: aName description: aDescription group: aGroupName
	^self basicNew
		initializeWithName: aName description: aDescription group: aGroupName;
		yourself! !

!WSConfigurationItem methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:28'!
description
	^description! !

!WSConfigurationItem methodsFor: '*webstore-admin' stamp: 'StuartHerring 9/6/2009 20:31'!
editField
	^WSField text
		label: name asCapitalizedPhrase;
		description: description;
		on: #value of: self;
		yourself.
		! !

!WSConfigurationItem methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:28'!
group
	^group! !

!WSConfigurationItem methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 16:28'!
initializeWithName: aName description: aDescription group: aGroupName
	self initialize.
	description := description.
	name := aName.
	group := aGroupName.! !

!WSConfigurationItem methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:28'!
name
	^name! !

!WSConfigurationItem methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:29'!
value
	^value! !

!WSConfigurationItem methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:29'!
value: arg
	value := arg! !

WSConfigurationItem subclass: #WSIntegerConfigurationItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSIntegerConfigurationItem methodsFor: '*webstore-admin' stamp: 'StuartHerring 9/9/2009 13:22'!
editField
	^WSField integer
		label: name asCapitalizedPhrase;
		description: description;
		on: #value of: self;
		yourself.
		! !

WSConfigurationItem subclass: #WSLargeTextConfigurationItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSLargeTextConfigurationItem methodsFor: '*webstore-admin' stamp: 'StuartHerring 11/14/2009 22:29'!
editField
	^WSField largeText
		label: name asCapitalizedPhrase;
		description: description;
		on: #value of: self;
		yourself.
		! !

WSConfigurationItem subclass: #WSNumericConfigurationItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSNumericConfigurationItem methodsFor: '*webstore-admin' stamp: 'StuartHerring 9/6/2009 20:35'!
editField
	^WSField numeric
		label: name asCapitalizedPhrase;
		description: description;
		on: #value of: self;
		yourself.
		! !

WSObject subclass: #WSCountry
	instanceVariableNames: 'code name'
	classVariableNames: 'Countries'
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:42'!
byCode: aCode 
	^ Countries at: aCode! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:15'!
code: twoLetterCode name: humanReadableName
	^self basicNew
		initializeWithCode: twoLetterCode name: humanReadableName;
		yourself! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:36'!
countryList
	^Countries values! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'srh 6/27/2009 10:36'!
new
	self shouldNotImplement! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2010 20:17'!
populateCountryListFromWeb
	"Open country codes is at : 'http://opencountrycodes.appspot.com/xml/' if it ever starts working again"
	^self populateCountryListWith:('http://stuartherring.net/countrycodes.xml' asUrl retrieveContents contentStream)
! !

!WSCountry class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2010 20:14'!
populateCountryListWith: aStream
	"Populates or repopulates the Country Code list from an OpenCountryCodes compatible XML stream."
	Countries := Dictionary new.
	(XMLDOMParser parseDocumentFrom: aStream) 
		tagsNamed: #country do: [ :e | 
			Countries at: (e attributeAt: #code) put: (WSCountry code: (e attributeAt: #code) name: (e attributeAt: #name))]! !

!WSCountry methodsFor: 'accessing' stamp: 'srh 6/27/2009 10:38'!
code
	^code! !

!WSCountry methodsFor: 'initialization' stamp: 'srh 6/27/2009 10:37'!
initializeWithCode: twoLetterCode name: humanReadableName
	self initialize.
	code := twoLetterCode.
	name := humanReadableName ! !

!WSCountry methodsFor: 'testing' stamp: 'StuartHerring 9/9/2009 13:58'!
isLocal 
	"TODO: Have this looked up instead"
	^code = 'AU'! !

!WSCountry methodsFor: 'accessing' stamp: 'srh 6/27/2009 10:38'!
name
	^name! !

!WSCountry methodsFor: 'testing' stamp: 'srh 6/27/2009 11:35'!
notEmpty
	^code notNil and: [ name notNil]! !

!WSCountry methodsFor: 'printing' stamp: 'StuartHerring 9/5/2009 13:44'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPutAll: ' (' , code , ' -> ';
		nextPutAll: name;
		nextPutAll: ')'! !

WSObject subclass: #WSCustomer
	instanceVariableNames: 'email name phone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCustomer class methodsFor: 'as yet unclassified' stamp: 'srh 2/22/2009 12:05'!
new
	^self basicNew
		initialize;
		yourself.! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
email
	^email! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
email: anEmailAddress
	email := anEmailAddress! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:50'!
name
	^name! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:53'!
name: aName
	name := aName! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:51'!
phone
	^phone! !

!WSCustomer methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:52'!
phone: aPhoneNumber
	phone := aPhoneNumber! !

WSObject subclass: #WSImage
	instanceVariableNames: 'baseName'
	classVariableNames: 'Extension Medium Thumb'
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSImage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/24/2009 11:21'!
cleanupImageDirectory
	"Searches the image directory for image files and deletes any not
	currently pointed to by a WSImage instance"
	| dir |
	dir := FileDirectory default directoryNamed: WSImage imageDir.
	dir fileNames
		do: [:f | WSImage allInstances
				detect: [:i | #(#fullsize #medium #preview #thumbnail )
						anySatisfy: [:sym | (i perform: sym) = f]]
				ifNone: [dir deleteFileNamed: f]]! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 22:42'!
fromStream: aStream
	^self basicNew
		initialize;
		generateImagesFrom: (ImageReadWriter formFromStream: aStream);
		yourself.
	! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/24/2009 10:56'!
imageDir
	^'files'! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:30'!
initialize
	super initialize.
	Extension := '.jpg'! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:30'!
mediumDimension
	^200@200.
! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
previewDimension
	^100@100.! !

!WSImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
thumbDimension
	^50@50.! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
fullsize
	^ baseName, '-full' , Extension! !

!WSImage methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:55'!
generateImages
	| image |
	image := Form fromFileNamed: (self pathFor: self fullsize).
	(image scaledToSize: WSImage thumbDimension) writeJPEGfileNamed: (self pathFor: self thumbnail).
	(image scaledToSize: WSImage previewDimension) writeJPEGfileNamed: (self pathFor: self preview).
	(image scaledToSize: WSImage mediumDimension) writeJPEGfileNamed: (self pathFor: self medium).
! !

!WSImage methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:25'!
generateImagesFrom: aForm.
	aForm writeJPEGfileNamed: (self pathFor: self fullsize).
	self generateImages! !

!WSImage methodsFor: 'initialization' stamp: 'srh 1/4/2009 11:33'!
initialize
	super initialize.
	baseName := UUID new printString! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:33'!
medium
	^ baseName, '-med' , Extension! !

!WSImage methodsFor: 'class migration' stamp: 'srh 7/25/2009 16:27'!
migrate
	baseName class = UUID ifTrue: [
		baseName := baseName printString.	
	].
	self generateImages.! !

!WSImage methodsFor: 'accessing' stamp: 'StuartHerring 9/24/2009 10:56'!
pathFor: aFilename
	^(FileDirectory default directoryNamed: self class imageDir) assureExistence fullName, FileDirectory slash, aFilename! !

!WSImage methodsFor: 'accessing' stamp: 'srh 7/27/2009 09:57'!
preview
	^ baseName, '-preview' , Extension! !

!WSImage methodsFor: 'accessing' stamp: 'srh 1/4/2009 11:32'!
thumbnail
	^ baseName, '-thumb' , Extension! !

WSObject subclass: #WSMessage
	instanceVariableNames: 'subject recipient message date sender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Messages'!

!WSMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:00'!
to: recipient from: sender subject: aSubject message: aMessage
	^self basicNew
		initialize;
		recipient: recipient;
		sender: sender;
		subject: aSubject;
		message: aMessage;
		yourself! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
date
	^date! !

!WSMessage methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 22:50'!
initialize
	super initialize.
	date := DateAndTime now.! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
message
	^message! !

!WSMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 22:58'!
message: aMessage
	message := aMessage! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:14'!
recipient
	^recipient! !

!WSMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 23:00'!
recipient: aRecipient
	recipient := aRecipient ! !

!WSMessage methodsFor: 'actions' stamp: 'StuartHerring 8/28/2009 20:49'!
send
	SeasidePlatformSupport deliverMailFrom: 'info@creativecorsetry.com.au'
		to: (Array with: self recipient)
		text: ('To: {1}\From: {2}\Subject: {3}\{4}' withCRs 
			format: {self recipient. self sender. self subject. self message})! !

!WSMessage methodsFor: 'actions' stamp: 'StuartHerring 8/28/2009 20:42'!
sender
	^sender! !

!WSMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 23:00'!
sender: aSender
	sender := aSender! !

!WSMessage methodsFor: 'accessing' stamp: 'srh 6/13/2009 16:15'!
subject
	^subject! !

!WSMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 22:58'!
subject: aSubject
	subject := aSubject! !

WSMessage subclass: #WSOrderStatusMessage
	instanceVariableNames: 'exp order'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Messages'!

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:11'!
adminNewOrder: order
	^self basicNew
		initializeWithOrder: order;
		beToAdmin;
		subject: '%cfg.emailPrefix %order.reference received, pending confirmation';
		message:  (self messageTextFor: #adminOrderEmail ifEmpty: 'Order %order.reference has been placed, and is awaiting payment confirmation');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:12'!
adminPaymentConfirmedForOrder: order
	^self basicNew
		initializeWithOrder: order;
		beToAdmin;
		subject: '%cfg.emailPrefix Order %order.reference Payment Confirmed';
		message:  (self messageTextFor: #adminConfirmedEmail ifEmpty: 'Payment has been confirmed for order %order.reference');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:12'!
customerNewOrder: order
	^self basicNew
		initializeWithOrder: order;
		beToCustomer;
		subject: '%cfg.emailPrefix %order.reference received, pending confirmation';
		message:  (self messageTextFor: #customerOrderEmail ifEmpty: 'This message verifies that your order was received, you will be notified once payment has been confirmed.
Your reference number is: %order.reference');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:13'!
customerOrderCancelled: order
	^self basicNew
		initializeWithOrder: order;
		beToCustomer;
		subject: '%cfg.emailPrefix Order %order.reference Cancelled';
		message:  (self messageTextFor: #customerCancelledEmail ifEmpty: 'This message is to inform you that your order %order.reference been cancelled because %status.reason.
If you believe this is in error, please contact us at %cfg.contactEmail');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:13'!
customerPaymentConfirmedForOrder: order
	^self basicNew
		initializeWithOrder: order;
		beToCustomer;
		subject: '%cfg.emailPrefix Order %order.reference Payment Confirmed';
		message:  (self messageTextFor: #customerConfirmedEmail ifEmpty: 'This messages confirms that your payment for order %order.reference has been confirmed.  Please expect 2-3 weeks while your corset is made.
You will be notified when your order ships');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/14/2009 23:11'!
customerShippedOrder: order 
	^self basicNew
		initializeWithOrder: order;
		beToCustomer;
		subject: '%cfg.emailPrefix Order %order.reference Shipped';
		message: (self messageTextFor: #customerShippedEmail ifEmpty: 'This messages confirms that your order %order.reference been shipped.
Your reference number is %status.reference');
		yourself.! !

!WSOrderStatusMessage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/15/2009 00:25'!
messageTextFor: aSymbol ifEmpty: message 
	(WSStoreServices configuration at: aSymbol) isEmptyOrNil ifTrue: [
		WSStoreServices commit: [
			WSStoreServices configuration at: aSymbol put: message]].
	^WSStoreServices configuration at: aSymbol.! !

!WSOrderStatusMessage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:08'!
beToAdmin
	recipient := WSStoreServices configuration at: #adminEmail.! !

!WSOrderStatusMessage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:05'!
beToCustomer
	recipient := order customer email.! !

!WSOrderStatusMessage methodsFor: 'initialization' stamp: 'StuartHerring 9/5/2009 23:07'!
initializeWithOrder: anOrder
	self initialize.
	order := anOrder.
	self setUpExpressions.
	sender := WSStoreServices configuration at: #fromEmail.
	self beToCustomer.! !

!WSOrderStatusMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:54'!
message: messageText
	super message: (exp process: messageText).! !

!WSOrderStatusMessage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/5/2009 23:07'!
setUpExpressions
	exp := WSExpressionEngine new.
	exp at: #order put: order.
	exp at: #status put: order status.
	exp at: #cfg put: WSStoreServices configuration.
! !

!WSOrderStatusMessage methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:55'!
subject: subjectText
	super subject: (exp process: subjectText)! !

!WSObject methodsFor: 'updating' stamp: 'StuartHerring 9/5/2009 12:24'!
announce: anAnnouncement
	| an |
	an := WSStoreServices announcer.
	an ifNotNil: [ an announce: anAnnouncement]! !

!WSObject methodsFor: 'class migration' stamp: 'srh 1/3/2009 09:42'!
migrate
	"Initialize new ivars added since the object was saved"
! !

WSObject subclass: #WSOption
	instanceVariableNames: 'name required'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^self subclassResponsibility! !

!WSOption methodsFor: '*webstore-components' stamp: 'StuartHerring 9/3/2009 23:20'!
asComponent
	^ self subclassResponsibility! !

!WSOption methodsFor: '*webstore-admin' stamp: 'StuartHerring 9/3/2009 22:12'!
editor
	^ WSOptionField option: self.! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:15'!
name
	^name! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
name: aName
	name := aName.! !

!WSOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:18'!
price
	^0! !

!WSOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:19'!
priceInDollars
	^(self price / 100) printShowingDecimalPlaces: 2! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 00:16'!
required
	^required! !

!WSOption methodsFor: 'accessing' stamp: 'srh 3/9/2009 11:01'!
required:  isRequired
	required := isRequired! !

!WSOption methodsFor: '*webstore-components' stamp: 'StuartHerring 9/3/2009 21:55'!
valueEditor
	^ self subclassResponsibility! !

WSOption subclass: #WSSimpleOption
	instanceVariableNames: 'description image price enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSSimpleOption class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 23:31'!
label
	^'Simple Option'! !

!WSSimpleOption methodsFor: '*webstore-components' stamp: 'StuartHerring 11/20/2009 19:09'!
asComponent
	^WSOptionComponent option: self! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:20'!
beRequired
	"Do nothing - doesn't make sense"! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:17'!
description
	^description! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:17'!
description: aDescription
	description := aDescription! !

!WSSimpleOption methodsFor: '*webstore-admin' stamp: 'StuartHerring 11/19/2009 23:43'!
editor
	^WSSimpleOptionEditor option: self! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:23'!
enabled
	^enabled! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:23'!
enabled: aBoolean
	enabled := aBoolean! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:17'!
image
	^image! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:17'!
image: aWSImage
	image := aWSImage! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:22'!
optionPrice
 "Use #optionPrice: and #optionPrice so as to not clash with #price -which is a run-time calculation of price.  
	#optionPrice needs to always display the list price even if the option is not selected"
	^price! !

!WSSimpleOption methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2009 23:21'!
optionPrice: aPriceInCents
	price := aPriceInCents! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2011 12:28'!
price
	^enabled ifTrue: [price] ifFalse: [0]! !

!WSSimpleOption methodsFor: 'accessing' stamp: 'StuartHerring 11/24/2009 17:58'!
required
	^false "Doesn't make sense for this to be required"! !

!WSSimpleOption methodsFor: 'evaluating' stamp: 'StuartHerring 11/20/2009 19:10'!
value
	^enabled 
		ifTrue: [ 'Yes' ]
		ifFalse: [ 'No' ]! !

!WSSimpleOption methodsFor: '*webstore-components' stamp: 'StuartHerring 11/20/2009 20:00'!
valueEditor
	^WSSimpleOptionValueEditor option: self! !

WSOption subclass: #WSTextOption
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSTextOption class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 10:03'!
label
	^'Text'! !

!WSTextOption methodsFor: '*webstore-components' stamp: 'srh 5/4/2009 17:40'!
asComponent
	^ WSOptionComponent option: self.! !

!WSTextOption methodsFor: 'accessing' stamp: 'srh 3/11/2009 14:10'!
text
	^text! !

!WSTextOption methodsFor: 'accessing' stamp: 'srh 3/11/2009 14:10'!
text: someText
	text := someText! !

!WSTextOption methodsFor: '*webstore-components' stamp: 'StuartHerring 9/3/2009 21:55'!
valueEditor
	^ WSField text 
		on: #text
		of: self! !

WSObject subclass: #WSOrder
	instanceVariableNames: 'items address customer status id history messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSOrder methodsFor: 'adding' stamp: 'StuartHerring 9/9/2009 15:32'!
add: aProduct
	self assertModifiable.
	items add: aProduct orderCopy! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
address
	^address! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:32'!
address: aShippingAddress
	self assertModifiable.
	address := aShippingAddress! !

!WSOrder methodsFor: 'enumerating' stamp: 'StuartHerring 9/9/2009 15:33'!
anySatisfy: aBlock
	^items anySatisfy: aBlock! !

!WSOrder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/9/2009 15:32'!
assertModifiable
	(status is: #new) ifFalse: [Error signal: 'This order cannot be modified']! !

!WSOrder methodsFor: 'actions' stamp: 'StuartHerring 9/5/2009 23:16'!
cancel: reason
	status cancel: reason.! !

!WSOrder methodsFor: 'initialization' stamp: 'StuartHerring 9/9/2009 15:30'!
clear
	self assertModifiable.
	items := OrderedCollection new.! !

!WSOrder methodsFor: 'actions' stamp: 'srh 2/28/2009 14:45'!
confirmPayment: reference
	status confirmPayment: reference! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:34'!
count
	^items size! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/1/2009 16:35'!
customer
	^customer! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:32'!
customer: aCustomer
	self assertModifiable.
	customer := aCustomer! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 16:14'!
date
	"The order date is the date of the first #unconfirmed status"
	^(history detect: [:s | s is: #unconfirmed] 
		ifNone: [ self error: 'Order hasn''t been placed yet']
	) date.! !

!WSOrder methodsFor: 'enumerating' stamp: 'StuartHerring 9/10/2009 06:09'!
detect: aBlock
	^items detect: aBlock! !

!WSOrder methodsFor: 'actions' stamp: 'StuartHerring 9/9/2009 15:35'!
do: aBlock
	items do: aBlock! !

!WSOrder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/10/2009 11:50'!
grandTotal 
	^self total + self shipping.! !

!WSOrder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/10/2009 11:50'!
grandTotalInDollars 
	^(self grandTotal / 100) printShowingDecimalPlaces: 2! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:33'!
history
	^history! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:52'!
includes: aProduct
	^items includes: aProduct! !

!WSOrder methodsFor: 'initialization' stamp: 'StuartHerring 9/9/2009 15:40'!
initialize
	super initialize.
	history := OrderedCollection new.
	items := OrderedCollection new.
	self status: (WSStatus newFor: self).! !

!WSOrder methodsFor: 'enumerating' stamp: 'StuartHerring 9/10/2009 06:15'!
inject: anObject into: aBlock
	^items inject: anObject  into: aBlock! !

!WSOrder methodsFor: 'testing' stamp: 'StuartHerring 9/9/2009 15:35'!
isEmpty
	^ items isEmpty! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2009 15:51'!
items
	^items copy! !

!WSOrder methodsFor: 'actions' stamp: 'srh 6/13/2009 15:51'!
logMessage: aMessage
	"Adds a message to the log"
	self messages add: aMessage! !

!WSOrder methodsFor: 'initialization' stamp: 'StuartHerring 9/10/2009 06:08'!
messages
	^messages ifNil: [ messages := OrderedCollection new].! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/11/2009 15:47'!
migrate
	items class name = #OrderedCollection ifFalse: [ items := (items instVarNamed: #items)].
	items do: [ :i | i migrate]! !

!WSOrder methodsFor: 'actions' stamp: 'StuartHerring 9/5/2009 23:18'!
placeOrder: orderId
	id := orderId.
	status placeOrder.
! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 12:13'!
reference
	^id! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 15:32'!
remove: aProduct
	self assertModifiable.
	items remove: aProduct.! !

!WSOrder methodsFor: 'actions' stamp: 'StuartHerring 9/5/2009 23:16'!
ship: aReference 
	status ship: aReference.! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 13:27'!
shipping
	^address isLocal 
		ifTrue: [ WSStoreServices configuration at: #localShipping]
		ifFalse: [ WSStoreServices configuration at: #internationalShipping]
	! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/9/2009 13:28'!
shippingInDollars 
	^(self shipping / 100) asFloat printShowingDecimalPlaces: 2.! !

!WSOrder methodsFor: 'accessing' stamp: 'srh 1/2/2009 08:59'!
status
	^status! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/5/2009 23:47'!
status: aStatus 
	status := aStatus.
	history add: aStatus.
	self announce: (WSStatusChanged order: self)! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 11/25/2009 10:35'!
total
	^items inject: 0 into: [:a :i| a + i total].! !

!WSOrder methodsFor: 'accessing' stamp: 'StuartHerring 9/10/2009 11:49'!
totalInDollars
	^(self total / 100) printShowingDecimalPlaces: 2.! !

WSObject subclass: #WSProduct
	instanceVariableNames: 'id name description price images preview enabled options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSProduct methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/4/2009 23:54'!
asTemplate
	| p |
	p := self class new.
	p  name: name.
	p description: description.
	p price: price.
	p options: options deepCopy.
	p disable.
	^p! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:29'!
description
	^description! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:30'!
description: aDescription
	description := aDescription.! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:58'!
disable
	enabled := false! !

!WSProduct methodsFor: 'actions' stamp: 'srh 12/31/2008 09:50'!
enable
	enabled := true! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/31/2008 09:50'!
enabled
	^enabled! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/28/2009 09:52'!
id
	^id! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/28/2009 10:01'!
id: anId
  id ifNotNil: [Error signal: 'cannot modify id once set'].
  id := anId! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 8/19/2010 16:59'!
images
	^images copy! !

!WSProduct methodsFor: 'actions' stamp: 'StuartHerring 9/17/2009 20:15'!
images: aCollection.
	images := aCollection.
	(images includes: preview) ifFalse: [ 
		aCollection notEmpty 
			ifTrue: [preview := images first]
			ifFalse: [preview := nil]]! !

!WSProduct methodsFor: 'initialization' stamp: 'srh 3/7/2009 19:37'!
initialize
	images := OrderedCollection new.
	enabled := false.	
	options := OrderedCollection new.! !

!WSProduct methodsFor: 'class migration' stamp: 'srh 3/8/2009 21:47'!
migrate
	images do: [ :i | i migrate].
	options ifNil: [options := OrderedCollection new].
	options do: [ :o| o migrate].! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name
	^name.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/28/2008 13:53'!
name: aName
	name := aName.! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 8/19/2010 17:02'!
options
	^options copy.! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 8/19/2010 17:04'!
options: anOrderedCollection
	options := anOrderedCollection copy.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 3/21/2009 14:20'!
orderCopy
	^self deepCopy.! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:19'!
preview
	^preview! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/30/2008 21:24'!
preview: anImage
	(images includes: anImage) ifFalse: [
		self error: 'Preview image must be one of the product''s images'
	].
	preview := anImage! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price
	^price! !

!WSProduct methodsFor: 'accessing' stamp: 'srh 12/29/2008 07:32'!
price: priceInCents
	price := priceInCents! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:27'!
priceInDollars
	^(self price / 100) printShowingDecimalPlaces: 2! !

!WSProduct methodsFor: 'actions' stamp: 'srh 3/7/2009 19:38'!
removeOption: anOption
	options remove: anOption! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:26'!
total
	"Price including option prices"
	^options inject: self price into: [ :total :option | total + option price ].! !

!WSProduct methodsFor: 'accessing' stamp: 'StuartHerring 11/19/2009 23:27'!
totalInDollars
	^(self total / 100) printShowingDecimalPlaces: 2! !

WSObject subclass: #WSStore
	instanceVariableNames: 'products orders orderId productId settings messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStore methodsFor: 'actions' stamp: 'srh 3/28/2009 10:07'!
addProduct: aProduct
	products add: (aProduct id: (self nextProductId); yourself).! !

!WSStore methodsFor: 'actions' stamp: 'srh 12/30/2008 14:45'!
deleteProduct: aProduct
	products remove: aProduct! !

!WSStore methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 21:49'!
initialize
	super initialize.
	products := OrderedCollection new.
	orders := OrderedCollection new.
	messages := OrderedCollection new.
	orderId := 0.
	productId := 0.
	settings := WSStoreSettings new.
	self setUpStoreDefaults.! !

!WSStore methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 21:49'!
logMessage: aMessage
	messages add: aMessage.! !

!WSStore methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 22:24'!
messages 
	^messages! !

!WSStore methodsFor: 'class migration' stamp: 'StuartHerring 9/8/2009 07:53'!
migrate
	"Initialize new ivars added since the object was saved"
	orderId ifNil: [orderId := 0].
	orders ifNil: [ orders := OrderedCollection new ].
	products do: [:p |
		p id ifNil: [ p id: self nextProductId].
		p migrate].
	orders do: [:o | o migrate.
		o messages do: [ :m |
			(messages includes: m) ifFalse: [messages add: m]]].
	messages ifNil: [messages := OrderedCollection new].
	settings ifNil: [ settings := WSStoreSettings new ].
	settings migrate.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 1/3/2009 09:40'!
nextOrderId
	orderId := orderId + 1.
	^orderId printString.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 3/28/2009 10:04'!
nextProductId
	productId := productId + 1.
	^productId printString.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:55'!
orders
	^orders! !

!WSStore methodsFor: 'actions' stamp: 'srh 1/3/2009 09:39'!
placeOrder: anOrder
	anOrder placeOrder: self nextOrderId.
	orders add: anOrder.! !

!WSStore methodsFor: 'accessing' stamp: 'srh 4/11/2009 12:31'!
productWithId: anId
	^products detect: [ :p | p id = anId ]! !

!WSStore methodsFor: 'accessing' stamp: 'srh 2/28/2009 14:56'!
products
	^products.! !

!WSStore methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 21:11'!
setUpStoreDefaults
	settings
		at: #localShipping put: 0;
		at: #internationalShipping put: 0;
		at: #smtpServer put: 'localhost'! !

!WSStore methodsFor: 'initialization' stamp: 'StuartHerring 8/22/2009 19:53'!
settings 
	^settings! !

WSObject subclass: #WSStoreSettings
	instanceVariableNames: 'localShipping internationalShipping settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStoreSettings class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/17/2009 12:42'!
allSettings
	
	^OrderedCollection new 
		add: (WSIntegerConfigurationItem 
			name: #localShipping 
			description: 'The price to charge for shipping to the same country, in cents' 
			group: #general);
		add: (WSIntegerConfigurationItem 
			name: #internationalShipping
			description: 'The price to charge for shipping overseas, in cents'
			group: #general);
		add: (WSConfigurationItem 
			name: #adminEmail
			description: 'The address to send admin emails'
			group: #email);
		add: (WSConfigurationItem 
			name: #fromEmail
			description: 'The address from which store emails will be sent'
			group: #email);
		add: (WSConfigurationItem 
			name: #emailPrefix
			description: 'The prefix text to use in the subject lines of emails'
			group: #email);
		add: (WSConfigurationItem 
			name: #contactEmail
			description: 'Contact address told to customers'
			group: #email);
		add: (WSConfigurationItem 
			name: #smtpServer
			description: 'The Mail server through which to send messages'
			group: #email);
		add: (WSLargeTextConfigurationItem 
			name: #customerOrderEmail
			description: 'The email sent to a customer when they first place an order'
			group: #messages);
		add: (WSLargeTextConfigurationItem 
			name: #customerConfirmedEmail
			description: 'The email sent to a customer when their payment is confirmed'
			group: #messages);
		add: (WSLargeTextConfigurationItem 
			name: #customerShippedEmail
			description: 'The email sent to a customer when their order ships'
			group: #messages);
		add: (WSLargeTextConfigurationItem 
			name: #customerCancelledEmail
			description: 'The email sent to a customer when their order is cancelled'
			group: #messages);
		add: (WSLargeTextConfigurationItem 
			name: #adminOrderEmail
			description: 'The email sent to the administrator when a customer places an order'
			group: #messages);
		add: (WSLargeTextConfigurationItem 
			name: #adminConfirmedEmail
			description: 'The email sent to the administrator when a payment is confirmed'
			group: #messages);
			
		yourself
			! !

!WSStoreSettings methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 20:25'!
addSetting: aSetting
	settings at: aSetting name asSymbol put: aSetting! !

!WSStoreSettings methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 16:34'!
at: aSymbol
	^(settings at: aSymbol) value! !

!WSStoreSettings methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 23:06'!
at: aSymbol put: aValue
	(settings at: aSymbol) value: aValue.! !

!WSStoreSettings methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2009 20:15'!
byGroup
	" Returns a dictionary, the keys of which are the Group symbol, the values a Collection of settings"
	| key result |
	result := Dictionary new.
	settings do: [ :s |
		key := s group.
		(result includesKey: key)
			ifFalse: [ result at: key put: OrderedCollection new].
		(result at: key) add: s].
	^result! !

!WSStoreSettings methodsFor: '*webstore-expression' stamp: 'StuartHerring 9/6/2009 22:59'!
expressionChild: aSymbol
	^self at: aSymbol! !

!WSStoreSettings methodsFor: 'initialization' stamp: 'StuartHerring 9/6/2009 23:04'!
initialize
	super initialize.
	settings := Dictionary new.
	self class allSettings do: [ :s |self addSetting: s]
			! !

!WSStoreSettings methodsFor: 'class migration' stamp: 'StuartHerring 11/17/2009 12:38'!
migrate
	settings ifNil: [settings := Dictionary new].
	self class allSettings do: [ :s | | key |
		key := s name asSymbol.
		(settings includesKey: key) 	
			ifTrue: [ s value: (settings at: key) value].
		self addSetting: s].
	settings keys do: [ :key |
		self class allSettings detect: [ :s | s name asSymbol = key] ifNone: [settings removeKey: key ]]
		
			
! !

!WSStoreSettings methodsFor: 'accessing' stamp: 'StuartHerring 9/6/2009 20:07'!
settings
	^settings! !

Object subclass: #WSRule
	instanceVariableNames: 'rule message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Util'!

!WSRule class methodsFor: 'as yet unclassified' stamp: 'srh 3/8/2009 17:41'!
rule: aBlock message: aMessage
	^self basicNew
		initializeWithRule:  aBlock message: aMessage;
		yourself.! !

!WSRule methodsFor: 'initialization' stamp: 'srh 3/8/2009 17:42'!
initializeWithRule: aRule message: aMessage
	message := aMessage.
	rule := aRule.
	self initialize! !

!WSRule methodsFor: 'accessing' stamp: 'srh 12/30/2008 19:02'!
message
	^message! !

!WSRule methodsFor: 'accessing' stamp: 'srh 12/30/2008 19:02'!
rule
	^rule! !

!WSRule methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 19:04'!
testRule: value
	^rule value: value! !

Object subclass: #WSStatus
	instanceVariableNames: 'date owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSStatus commentStamp: 'srh 2/28/2009 11:22' prior: 0!
A WSStatus represents the current status of an order

Instance Variables
	date:		<Object>
	owner:		<WSOrder> (or, technically anything implementing #state:)
date
	- The date and time the current status was entered
	
owner
	- The class 'owning' this state. #state: is called on this class to change its state.
!

WSStatus subclass: #WSCancelledStatus
	instanceVariableNames: 'reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject
	self shouldNotImplement.! !

!WSCancelledStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 14:00'!
owner: anObject reason: aString
	^self basicNew
		initializeWithOwner: anObject reason: aString;
		yourself! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2009 22:25'!
details
	^self reason! !

!WSCancelledStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 13:59'!
initializeWithOwner: anOwner reason: aString
	self initializeWithOwner: anOwner.
	reason := aString.! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#cancelled! !

!WSCancelledStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 13:59'!
reason
	^reason! !

WSStatus subclass: #WSConfirmedStatus
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject
	^self shouldNotImplement! !

!WSConfirmedStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 12:33'!
owner: anObject reference: aString
	^self basicNew
		initializeWithOwner: anObject reference: aString;
		yourself.! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:01'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2009 22:25'!
details
	^self reference! !

!WSConfirmedStatus methodsFor: 'initialization' stamp: 'srh 2/28/2009 12:34'!
initializeWithOwner: anOwner reference: aString
	self initializeWithOwner: anOwner.
	reference := aString.! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#confirmed! !

!WSConfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 12:34'!
reference
	^reference! !

!WSConfirmedStatus methodsFor: 'actions' stamp: 'StuartHerring 9/1/2009 22:45'!
ship: reference 
	^ owner status: (WSShippedStatus owner: owner reference: reference)! !

WSStatus subclass: #WSNewStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSNewStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:01'!
name
	^#new! !

!WSNewStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
placeOrder
	^ owner status: (WSUnconfirmedStatus owner: owner)! !

WSStatus subclass: #WSShippedStatus
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSShippedStatus class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:28'!
owner: anObject
	^self shouldNotImplement! !

!WSShippedStatus class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2009 22:28'!
owner: anObject reference: aString
	^self basicNew
		initializeWithOwner: anObject reference: aString;
		yourself.! !

!WSShippedStatus methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2009 23:12'!
details
	^self reference! !

!WSShippedStatus methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2009 22:27'!
initializeWithOwner: anOwner reference: aString
	self initializeWithOwner: anOwner.
	reference := aString.! !

!WSShippedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#shipped! !

!WSShippedStatus methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2009 22:27'!
reference 
	^reference ! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:47'!
new
	self shouldNotImplement.! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:48'!
newFor: anOwner
	^WSNewStatus owner: anOwner! !

!WSStatus class methodsFor: 'as yet unclassified' stamp: 'srh 2/28/2009 11:21'!
owner: anObject
	^self basicNew
		initializeWithOwner: anObject;
		yourself.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:39'!
cancel: reason
	^self invalidStateChange: #cancel! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 12:39'!
confirmPayment: aReference
	^self invalidStateChange: #confirmPayment! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:06'!
date
	^date! !

!WSStatus methodsFor: 'initialization' stamp: 'srh 4/27/2009 12:35'!
details
	^''! !

!WSStatus methodsFor: 'initialization' stamp: 'srh 3/9/2009 11:12'!
initializeWithOwner: anObject
	self initialize.
	owner := anObject.
	date := DateAndTime now.
! !

!WSStatus methodsFor: 'error handling' stamp: 'srh 2/28/2009 11:28'!
invalidStateChange: aSymbol
	self error: 'The message ', aSymbol printString, ' does not make sense for the state ', self name printString! !

!WSStatus methodsFor: 'testing' stamp: 'srh 2/28/2009 11:05'!
is: aSymbol
	^self name = aSymbol! !

!WSStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 10:59'!
name
	^self subclassResponsibility.! !

!WSStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 11:29'!
placeOrder
	^self invalidStateChange: #placeOrder! !

!WSStatus methodsFor: 'actions' stamp: 'StuartHerring 9/1/2009 23:02'!
ship: reference
	^self invalidStateChange: #ship! !

WSStatus subclass: #WSUnconfirmedStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebStore-Core'!

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 14:07'!
cancel: reason
	^ owner status: (WSCancelledStatus owner: owner reason: reason)! !

!WSUnconfirmedStatus methodsFor: 'actions' stamp: 'srh 2/28/2009 13:40'!
confirmPayment: aReference 
	^ owner status: (WSConfirmedStatus 
			owner: owner
			reference: aReference)! !

!WSUnconfirmedStatus methodsFor: 'accessing' stamp: 'srh 2/28/2009 11:03'!
name
	^#unconfirmed! !
WSConnectionPool initialize!
WSImage initialize!
